import re
from os import popen
from os import getcwd
from os import chdir
from os import system
from os import path
from os import mkdir	
import sys
import StructBuilder
import ResiduObj

__doc__ = """Module pour l'assignation d'un modele proteique en structure secondaire par KAKSI"""

Progkaksi = "/home/lamarck/joseph/softwares/kaksi/kaksi-1.0.1/kaksi"
Progk2r = "/home/lamarck/joseph/softwares/kaksi/kaksi-1.0.1/xml/k2r"
#ProgKAKSI = "KAKSICMBI.EXE"


#-------------------------------------------------------------------------------------------------------------
class KAKSIbreakDansPartieProt (Exception):
	def __init__(self ):
		print >>sys.stderr, "Dssp place un break au milieu d'une partie que mon parser a defini sans break !!"
#-------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------
class InfoKAKSIetEnregistrementDiff (Exception):
	def __init__(self ):
		print >>sys.stderr, "Les infos donnees par KAKSI sont differentes de celles enregitrees"
#-------------------------------------------------------------------------------------------------------------



def Lancer_KAKSI (nomFichierPDB, nomtempKAKSI, nomSortieKAKSI):
	"""Methode pour lancer la commance KAKSI"""
	temp_dir = getcwd()
#	print ProgKAKSI,nomFichierPDB, nomSortieKAKSI
	commande = "%s -pf %s   2> /dev/null > %s"%(Progkaksi,nomFichierPDB, nomtempKAKSI)
	popen(commande) 
	command = "%s -kxo %s -pks  2> /dev/null > %s"%(Progk2r,nomtempKAKSI, nomSortieKAKSI)
	popen(command)
	system("rm -f %s"%(nomtempKAKSI))
	
	
	

def LectureSortieKAKSI (nomSortieKAKSI, chain_id):
	"""Methode pour la lecture et la recuperation des infos donnees par KAKSI"""

	ListeInfoKAKSI = []
#	print "entering segno parsing"
#	print nomSortieKAKSI		
	#Lecture de la sortie de segno
	try: 
		Fichkaksi = open(nomSortieKAKSI)
		Lignekaksi = Fichkaksi.readlines()
		Fichkaksi.close()
	except IOError, msg:
		print msg
		print "Secondary structure assignment by KAKSI failed"

#	print Lignesegno
	#Recup des infos
	if Lignekaksi != None:
#		print "lines found"
		flag_enter = 0
		Listeligne = []
		for ligne in Lignekaksi:
			if flag_enter == 1:
				for i in range(len(ligne)):
					Listeligne.append(ligne[i])
				Listeligne.pop()
			if ligne[0] == ">" and ligne[5] == chain_id:
#				print "found first line"
				flag_enter = 1	
		ListeInfoKAKSI = Listeligne
	return ListeInfoKAKSI

def AssignationKAKSI (NomProt,model , IDchaine, RepertoirePDBPartieProt, RepertoireSortieKAKSI):
	"""Methode pour l'assignation en SII par KAKSI pour chaque partie de la prot"""
	
	#print PartieProt
	
	#Ouvrir le PDB de la partie de la prot donnee dans sa conformation desiree
	if IDchaine == " ": CharChaine = "_"
	else : CharChaine = IDchaine
	NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
#	FichierPDB = open(NomFichierPDB,"w")
	
	#Ecrire le PDB
#	LignesPDB = []
#	NumAtom = [0]
#	for i in range(len(PartieProt)):
#		#print i
#		PartieProt[i].ResiduTOListOfString_PDB (NumAtom,IDchaine ,LignesPDB,altloc[i],NumRes=numDebPartieProt+i) 
#		#print stringList
#	LignesPDB.append("TER\n")
#	FichierPDB.writelines(LignesPDB)
	#print LignesPDB
	
	#Fermeture fichier PDB
#	FichierPDB.close()
	#print "PDB ouvert"
	
	if not path.exists(RepertoireSortieKAKSI):
		mkdir(RepertoireSortieKAKSI)
	kaksi_file = NomProt+"_"+`model`+"_"+CharChaine+".kak"
	#Lancement de KAKSI sur le fichier creer et recup des informations
	nomSortieKAKSI = RepertoireSortieKAKSI+"/"+NomProt+"_"+`model`+"_"+CharChaine+".kak"
	nomtempKAKSI = RepertoireSortieKAKSI+"/"+NomProt+"_"+`model`+"_"+CharChaine+".kxo"
	Lancer_KAKSI (NomFichierPDB, nomtempKAKSI, nomSortieKAKSI)
	#print "KAKSI fini"
	ListeInfoKAKSI = LectureSortieKAKSI (nomSortieKAKSI, IDchaine)
	if not RepertoireSortieKAKSI.split("/")[-1] == "temp_kaksi":
		cur_dir = getcwd()
		chdir(RepertoireSortieKAKSI)
		command = "tar cf - "+kaksi_file+"|"+"gzip -c >"+kaksi_file+".tar.gz"
		system(command)
		chdir(cur_dir)
		system("rm -f "+nomSortieKAKSI)
	else: system("rm -f "+nomSortieKAKSI)	
	#print " --> ListeInfoKAKSI" ,ListeInfoKAKSI
	
#	print ListeInfoKAKSI
	return ListeInfoKAKSI


	

# TEST ----------------------		
def main ():
	S1 = StructBuilder.StructBuilder("testPDB3.pdb")
	S1.Build_Chains()
	S1.Proteine.Chaines['A'].ModelsStruct[0].setMemoConformationsAlternatives_Ca()
	#LectureSortieKAKSI("testPDB3.segno")
	print S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA
	altloc = S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA[0][1]
	print "altloc",altloc
	
	seq_Struct= S1.Proteine.Chaines['A'].ModelsStruct[0].Seq_Struct
	Partie1 = []
	j = 0  #suivi des CA dans les listes de conformations alternatives (si besoin)
	PartieProt =0
	for i in range(len(seq_Struct)):
		if seq_Struct[i].__class__ == ResiduObj.Residu :
			Partie1.append(seq_Struct[i])
			j+= 1
		else:
			if j != 0:
				break
		
	AssignationKAKSI ("PDB3","A", Partie1 ,altloc, PartieProt+1, 1, 3,2, ".", ".")

if __name__ == "__main__":
	main()
