
import re
from os import popen
from os import system
from os import chdir
from os import mkdir
from os import path
from os import getcwd
from os import pardir
import sys
import math
import ResiduObj
import cPickle

__doc__ = """Module destine a l'assignation de SII par STRIDE de proteines PDB parsees et enregistrees en cPickle."""

ProgPM = "/home/lamarck/joseph/softwares/promotif/promotif.scr"

delta = 0.1

#-------------------------------------------------------------------------------------------------------------
class InfoSTRIDEetEnregistrementDiff (Exception):
	def __init__(self ):
		print >>sys.stderr, "Les infos donnees par Stride sont differentes de celles enregitrees"
#-------------------------------------------------------------------------------------------------------------



def Lancer_PM (nomFichierPDB, dir_PM):
	"""Methode pour lancer la commance PM. N'ecrit pas un fichier : return le resultat sous forme de stringIO"""
	pdb_file = nomFichierPDB.split("/")[-1]
	chain_name = pdb_file.split(".")[0]
	current_dir = getcwd()
#	mkdir(dir_PM+"/"+chain_name)
#	temp_dir = dir_PM+"/"+chain_name
	if not path.exists(dir_PM):
		mkdir(dir_PM)
	system("cp "+nomFichierPDB+" "+dir_PM)
	chdir(dir_PM)
	commande = "%s %s > /dev/null"%(ProgPM,pdb_file)
	print commande
	popen(commande) 
	system("rm -f *.ps")
	chdir(current_dir)
	


def LectureSortiePM (listfiles, chain_id, pos_str):
	"""Methode pour la lecture et la recuperation des infos donnees par STRIDE"""

	dict_PM = {}
#	list_bturns = {}
#	list_gturns = {}
#	list_blg = {}
#	list_hlx = {}
#	list_str = {}
#	list_hpin = {} 
#	flag_nofile = 0
	#Lecture de la sortie de stride
        try:
                file_hlx = open(listfiles[3], 'r') 
                lines_hlx = file_hlx.readlines() 
                file_hlx.close() 
                if len(lines_hlx) != 0:  
                        for lines in lines_hlx:  
                                list_hlx = [] 
                                if lines[4:5] == chain_id:  
                                        list_hlx.append(lines[20:21])# helix type: alpha or 3;10  
                                        list_hlx.append(lines[23:25])# helix length  
                                        list_hlx.append(lines[26:35])# SS of four neighboring residues on both sides  
                                        list_hlx.append(lines[37:42])# length in Angstroms  
                                        list_hlx.append(lines[45:49])# unit rise in Angstroms  
                                        list_hlx.append(lines[52:56])# residues per turn  
                                        list_hlx.append(lines[59:63])# pitch  
                                        list_hlx.append(lines[65:69])# measure of linearity  
                                        list_hlx.append(lines[70:71])
					try: 
                                        	dict_PM[lines[7:12]].append(list_hlx) 
					except KeyError:
						dict_PM[lines[7:12]] = [] 
						dict_PM[lines[7:12]].append(list_hlx)
                                        list_hlx.append(lines[69+int(list_hlx[1]):70+int(list_hlx[1])])  
					try: dict_PM[lines[14:19]].append(list_hlx) 
					except KeyError: 
						dict_PM[lines[14:19]] = []
						dict_PM[lines[14:19]].append(list_hlx)
					for pos in pos_str:
						if int(pos[:-1]) > int(lines[7:11]) and int(pos[:-1]) < int(lines[14:18]):
							try: dict_PM[pos].append(list_hlx)
							except KeyError: 
								dict_PM[pos] = []
								dict_PM[pos].append(list_hlx)

                        print "hlx" 
        except IOError, msg: 
                print msg
                print "Promotif helix assignment file missing!!" 



        try:
                file_str = open(listfiles[4], 'r') 
                lines_str = file_str.readlines() 
                file_str.close() 
                if len(lines_str) != 0:  
                        for lines in lines_str:  
                                list_str = []  
                                if lines[5:6] == chain_id:  
                                        list_str.append("E")  
                                        list_str.append(lines[20:23])# sheet number  
                                        list_str.append(lines[28:31])# strand length  
                                        list_str.append(lines[58:59])# number of strands hyd bonded with  
                                        list_str.append(lines[60:63])# strand number of first partner  
                                        list_str.append(lines[64:67])# number of second partner  
                                        list_str.append(lines[68:71])# number of third  
                                        list_str.append(lines[72:75])  
                                        list_str.append(lines[75:79])# orientation of partners  
                                        list_str.append(lines[79:82])# type of connection with partner (Richardson classification)  
                                        list_str.append(lines[82:85])# type of connection with partner (Richardson classification)  
                                        list_str.append(lines[86:94])# 4 neighbors on both sides  
                                        list_str.append(lines[32:33]) 
                                        list_str.append(lines[32:33]) 
					try: dict_PM[lines[6:11]].append(list_str)
                                        except KeyError: 
						dict_PM[lines[6:11]] = []
						dict_PM[lines[6:11]].append(list_str) 
                                        list_str.append(lines[31+int(list_str[2]):32+int(list_str[2])])  
					try: dict_PM[lines[13:18]].append(list_str)
                                        except KeyError: 
						dict_PM[lines[13:18]] = []
						dict_PM[lines[13:18]].append(list_str) 
                                        for pos in pos_str: 
                                                if int(pos[:-1]) > int(lines[6:10]) and int(pos[:-1]) < int(lines[13:17]): 
							try: dict_PM[pos].append(list_str)
                                                        except KeyError: 
								dict_PM[pos] = []
								dict_PM[pos].append(list_str)
        except IOError, msg: 
                print msg 
                print "Promotif strand assignment file missing!!" 



	try: 
		file_bturns = open(listfiles[0], 'r')
		lines_bturns = file_bturns.readlines()
		file_bturns.close()	
	        if len(lines_bturns) != 0: 
        	        for lines in lines_bturns: 
                	        list_bturns = [] 
                        	if lines[:1] == chain_id: 
                                	list_bturns.append("BT"+lines[29:33])# bturn type 
	                                list_bturns.append(lines[34:37])# location in Richardsons Ramachandran plot 
        	                        list_bturns.append(lines[63:66])# dist between first and fourth residue 
                	                list_bturns.append(lines[67:68])# whether a hyd bond is involved
					list_bturns.append(lines[6:7]) 
					try: dict_PM[lines[1:6]].append(list_bturns)
                        	        except KeyError: 
						dict_PM[lines[1:6]] = []	
						dict_PM[lines[1:6]].append(list_bturns)
					list_bturns.append(lines[13:14]) 
					try: dict_PM[lines[8:13]].append(list_bturns)
	                                except KeyError: 
						dict_PM[lines[8:13]] = []
						dict_PM[lines[8:13]].append(list_bturns)
					list_bturns.append(lines[20:21])
					try: dict_PM[lines[15:20]].append(list_bturns)
        	                        except KeyError: 
						dict_PM[lines[15:20]] = []
						dict_PM[lines[15:20]].append(list_bturns)
					list_bturns.append(lines[27:28])
					try: dict_PM[lines[22:27]].append(list_bturns)
                	                except KeyError: 
						dict_PM[lines[22:27]] = []
						dict_PM[lines[22:27]].append(list_bturns) 

	except IOError, msg:
		print msg
		print "Promotif bturn assignment file missing"


        try: 
		file_gturns = open(listfiles[1], 'r')
                lines_gturns = file_gturns.readlines()
                file_gturns.close()

	        if len(lines_gturns) != 0: 
        	        for lines in lines_gturns: 
                	        list_gturns = [] 
                        	if lines[:1] == chain_id: 
                                	list_gturns.append("GT" + lines[22:25])# inverse or classic gturn 
	                                list_gturns.append(lines[30:31])# ramachandran region 
        	                        list_gturns.append(lines[44:48])# dist between first and third residue 
                	                list_gturns.append(lines[6:7])
					try: dict_PM[lines[1:6]].append(list_gturns)
					except KeyError: 
						dict_PM[lines[1:6]] = []
						dict_PM[lines[1:6]].append(list_gturns)
					list_gturns.append(lines[13:14]) 
					try: dict_PM[lines[8:13]].append(list_gturns)
                        	        except KeyError: 
						dict_PM[lines[8:13]] = []
						dict_PM[lines[8:13]].append(list_gturns)
					list_gturns.append(lines[20:21]) 
					try: dict_PM[lines[15:20]].append(list_gturns)
                                	except KeyError: 
						dict_PM[lines[15:20]] = []
						dict_PM[lines[15:20]].append(list_gturns)

        except IOError, msg:
                print msg
                print "Promotif gturn assignment file missing!!"


        try: 
		file_blg = open(listfiles[2], 'r')
        	lines_blg = file_blg.readlines()
                file_blg.close()
	        if len(lines_blg) != 0: 
        	        for lines in lines_blg: 
                	        list_blg = [] 
                        	if lines[4:5] == chain_id: 
                                	list_blg.append(lines[0:4]) 
	                                i = 29 
					try: dict_PM[lines[5:10]].append([list_blg[0] + "X", lines[11:12]])
        	                        except KeyError: 
						dict_PM[lines[5:10]] = []
						dict_PM[lines[5:10]].append([list_blg[0] + "X", lines[11:12]])
					list_blg.append(lines[35:36])
					try: dict_PM[lines[29:34]].append(list_blg)
                	                except KeyError: 
						dict_PM[lines[29:34]] = []
						dict_PM[lines[29:34]].append(list_blg) 
                        	        res_prev = lines[29:33] 
                                	while i < 150: 
                                        	try:  
                                                	if int(res_prev) == int(lines[i+24:i+24+5][:-1]) or int(res_prev) == (int(lines[i+24:i+24+5][:-1]) - 1): 
                                                        	i = i +24 
	                                                        res_prev = lines[i:i+4]
								list_blg.append(lines[i+6:i+7])
        	                                                try: dict_PM[lines[i:i+5]].append(list_blg)
								except KeyError: 
									dict_PM[lines[i:i+5]] = []
									dict_PM[lines[i:i+5]].append(list_blg) 
                	                 
                        	                        else: break 
                                	        except ValueError: break 
        except IOError, msg:
                print msg
                print "Promotif bbulge assignment file missing!!"


        try: 
		file_hpin = open(listfiles[5], 'r')
                lines_hpin = file_hpin.readlines()
                file_hpin.close()
	        if len(lines_hpin) != 0: 
        	        for lines in lines_hpin: 
                	        list_hpin = [] 
                        	if lines[8:9] == chain_id and lines[15:16] == chain_id and lines[39:40] == ":": 
	                                list_hpin.append("HP" + lines[38:48].replace(" ","")) 
        	                        list_hpin.append(lines[1:4])# strand number 
                	                list_hpin.append(lines[5:7])# strand number 
                        	        if lines[16:17] == " ": 
                                	        res_start  = " " + `(int(lines[16:20])+1)` + lines[20:21] 
	                                else: res_start = lines[16:17] + `(int(lines[16:20])+1)` + lines[20:21] 
        	                        if lines[23:24] == " ":  
                	                        res_end = " " + `(int(lines[23:27])-1)` + lines[28:29] 
                        	        else: res_end = lines[23:24] + `(int(lines[23:27])-1)` + lines[28:29]      
					try: dict_PM[res_start].append(list_hpin)
                                	except KeyError: 
						dict_PM[res_start] = []
						dict_PM[res_start].append(list_hpin)
					try: dict_PM[res_end].append(list_hpin)
	                                except KeyError: 
						dict_PM[res_end] = []
						dict_PM[res_end].append(list_hpin) 
                                        for pos in pos_str: 
                                                if int(pos[:-1]) > int(res_start[:-1]) and int(pos[:-1]) < int(res_end[:-1]): 
							try: dict_PM[pos].append(list_hpin)
                                                        except KeyError: 
								dict_PM[pos] = []		
								dict_PM[pos].append(list_hpin)


        except IOError, msg:
                print msg
                print "hairpin assignment file missing!!"

	return dict_PM
	
	
def Recup_AssignationPM (NomProt,model, IDchaine, RepertoirePDBPartieProt, dir_PM, pos_str):
	"""Methode pour lancer STRIDE et recuperer les lignes d'assgination"""
	
	#Nom du PDB de la partie de la prot donnee dans sa conformation desiree
	if IDchaine == " ": CharChaine = "_"
	else : CharChaine = IDchaine
	NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
#	print NomFichierPDB

	
	
	pdb_name = NomProt+"_"+`model`+"_"+CharChaine
	file_bturns = dir_PM+"/"+pdb_name+".bturns"
	file_gturns = dir_PM+"/"+pdb_name+".gturns"
	file_blg = dir_PM+"/"+pdb_name+".blg"
	file_hlx = dir_PM+"/"+pdb_name+".hlx"
	file_str = dir_PM+"/"+pdb_name+".str"
	file_hpin = dir_PM+"/"+pdb_name+".hpin"
	#Lancement de STRIDE
	Lancer_PM (NomFichierPDB, dir_PM)
	
	list_files = [file_bturns,file_gturns,file_blg,file_hlx,file_str,file_hpin]
	#Lecture de la sortie de stride et renvoie des lignes d'assignation
	List_PM = LectureSortiePM (list_files, IDchaine, pos_str)
	if dir_PM.split("/")[-1] != "temp_promotif":
		cur_dir = getcwd()
		chdir(dir_PM+"/..")
		command = "tar cf - "+dir_PM.split("/")[-1]+"| gzip -c >"+dir_PM.split("/")[-1]+".tar.gz"
		system(command)
		chdir(cur_dir)
		system("rm -rf "+dir_PM)
	else: system("rm -rf "+dir_PM+"/*")
	return List_PM

def Modelset_SIIParRes_STRIDE (ObjetModele,NomPDB,IDchaine,RepertoirePDBPartieProt ,verif=True):
	"""Methode permettant d'assigner temporairement la PREMIERE (max occupancy moyenne) conformation possible d'un modele residu par residu avec Stride.
	L'option verif donne la possibilite de verifier la concordance des angles phi/psi enregistres et ceux calcules par Stride 
	On renvoie une liste avec l'assignation de la sequence complete. 
	On efface finalement cette assignation temporaire."""
	dictGlobalStride = {}
	#Recuperation des assignations STRIDE de chaque Partie du modele
	if ObjetModele.ListeIndicesPartiesProt == None :
		ObjetModele.getIndicesDebFinPartie()
	listeIndicesDebFinPartie = ObjetModele.ListeIndicesPartiesProt 
	for numPart in range(len(listeIndicesDebFinPartie)):
		dictGlobalStride.update(Recup_AssignationSTRIDE (NomPDB,IDchaine, numPart, listeIndicesDebFinPartie[numPart][0], listeIndicesDebFinPartie[numPart][1],0, RepertoirePDBPartieProt))
	
	#print dictGlobalStride
	#Pour la verification de la concordance des angles Phi/psi
	comptErreur = 0
	
	#Parcours de la sequence globale
	for i in range(len(ObjetModele.Seq_Struct)):
		res = ObjetModele.Seq_Struct[i]
		
		#Si assignation Stride non disponible : Partie de sequence trop courte (< 5 res), break,residu incomplet
		if not dictGlobalStride.has_key(i) :
			res.setAttributTEMP ("#")
		else :
			#Verification minimum : on verifie que le nom du residu correspond
			#print res.Type, i
			if res.Type == dictGlobalStride[i][0] :
				#Enregistrement temporaire de l'assignation STRIDE
				res.setAttributTEMP (dictGlobalStride[i][2])
			else :
				raise InfoSTRIDEetEnregistrementDiff()
			#Verification de la concordance des angles Phi/psi
			if verif == True :
				AnglePhienr = res.AnglesPhiPsi['Phi'][0]
				#print AnglePhienr
				AnglePsienr = res.AnglesPhiPsi['Psi'][0]
				#print AnglePsienr
				AnglePhistride = dictGlobalStride[i][3]
				if AnglePhistride == 360.0 : AnglePhistride = 999
				#print AnglePhistride
				AnglePsistride = dictGlobalStride[i][4]
				if AnglePsistride ==360.0  : AnglePsistride = 999
				#print AnglePsistride
				if (math.fabs(AnglePhienr) > math.fabs(AnglePhistride)+delta  or math.fabs(AnglePhienr) < math.fabs(AnglePhistride)-delta) : #angle phi different dans STRIDE et enregistrement (fabs : car Stride peut parfois mal lire un fichier ??? et donner des Phi/Psi opposes)
					comptErreur += 1
					#print "DIFF !!!"
				if (math.fabs(AnglePsienr) > math.fabs(AnglePsistride)+delta  or math.fabs(AnglePsienr )< math.fabs(AnglePsistride)-delta)  : #angle psi different dans STRIDE et enregistrement
					comptErreur += 1
					#print "DIFF !!"
					
	
	#Comptabilisation du nombre d'erreurs
	if comptErreur/len(ObjetModele.Seq_Struct) > 0.05 :
		raise InfoSTRIDEetEnregistrementDiff()
	#Recuperation de la liste global d'assignation
	assignationsSTRIDE = [res.getAttributTEMP(0) for res in ObjetModele.Seq_Struct]
	#liberation de l'attribut temporaire
	[res.Del_AttributTEMP() for res in ObjetModele.Seq_Struct]
	
	return assignationsSTRIDE


# TEST ----------------------		
def main ():
	
	RepertoirePDBPartieProt = "PDBsClean_Parties"
	system("tar -zxf '"+RepertoirePDBPartieProt+"/"+"pdb2b97.ent"+"_Chaine"+"A"+"_Mod"+'0'+".tgz' ")
	lignes = Recup_AssignationSTRIDE ("pdb2b97.ent","A", 0, 0,69,0, "PDBsClean_Parties")
	system("rm -rf "+RepertoirePDBPartieProt+"/*"+"2b97"+"*.pdb")	
#	print lignes
	
#	PDB ="pdb2b97.ent"
#	Chaine = "A"
	PDB ="pdb2c49.ent"
	Chaine = "A"
	PDB ="pdb2cb5.ent"
	Chaine = "B"

	
	fp = open("PDBsPickle/"+PDB,'r')
	prot = cPickle.load(fp)
	fp.close()
	print prot.Chaines[Chaine ].ModelsStruct[0].memoNombreConformationsALT_CA
	system("tar -zxf '"+RepertoirePDBPartieProt+"/"+PDB+"_Chaine"+Chaine+"_Mod"+'0'+".tgz' ")
	print Modelset_SIIParRes_STRIDE (prot.Chaines[Chaine ].ModelsStruct[0],PDB,Chaine,RepertoirePDBPartieProt ,verif=True)
	system("rm -rf "+RepertoirePDBPartieProt+"/*"+PDB+"*.pdb")	
	
	
	
if __name__ == "__main__":
	main()
	
