import re
from os import popen
from os import getcwd
from os import chdir
from os import system
from os import path
from os import mkdir	
import sys
import StructBuilder
import ResiduObj

__doc__ = """Module pour l'assignation d'un modele proteique en structure secondaire par SEGNO"""

Progsegno = "/home/lamarck/joseph/softwares/segno/segno"
#ProgSEGNO = "SEGNOCMBI.EXE"


#-------------------------------------------------------------------------------------------------------------
class SEGNObreakDansPartieProt (Exception):
	def __init__(self ):
		print >>sys.stderr, "Dssp place un break au milieu d'une partie que mon parser a defini sans break !!"
#-------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------
class InfoSEGNOetEnregistrementDiff (Exception):
	def __init__(self ):
		print >>sys.stderr, "Les infos donnees par SEGNO sont differentes de celles enregitrees"
#-------------------------------------------------------------------------------------------------------------



def Lancer_SEGNO (nomFichierPDB, nomSortieSEGNO):
	"""Methode pour lancer la commance SEGNO"""
	temp_dir = getcwd()
#	print ProgSEGNO,nomFichierPDB, nomSortieSEGNO
	commande = "%s -pdb %s   2> /dev/null > %s"%(Progsegno,nomFichierPDB, nomSortieSEGNO)
	popen(commande) 
	
	
	

def LectureSortieSEGNO (nomSortieSEGNO, chain_id):
	"""Methode pour la lecture et la recuperation des infos donnees par SEGNO"""

	ListeInfoSEGNO = {}
	flag_nofile = 0
#	print "entering segno parsing"
#	print nomSortieSEGNO		
	#Lecture de la sortie de segno
	try: 
		Fichsegno = open(nomSortieSEGNO)
		Lignesegno = Fichsegno.readlines()
		Fichsegno.close()
	except IOError, msg:
		print msg
		print "Secondary structure assignment by SEGNO failed"

#	print Lignesegno
	#Recup des infos
	if Lignesegno != None:
		for ligne in Lignesegno:
			if ligne[11] == chain_id:	
				Listeligne = []
				if not ligne[32] == " ":
					Listeligne.append(ligne[32]) #Assignment
				else: Listeligne.append("C")	
				Listeligne.append(ligne[7:10])
				#print int(ligne[6:10])
				ListeInfoSEGNO[ligne[1:6]] = Listeligne
				#print Listeligne
				
			
	return ListeInfoSEGNO

def AssignationSEGNO (NomProt,model , IDchaine, RepertoirePDBPartieProt, RepertoireSortieSEGNO):
	"""Methode pour l'assignation en SII par SEGNO pour chaque partie de la prot"""
	
	#print PartieProt
	
	#Ouvrir le PDB de la partie de la prot donnee dans sa conformation desiree
	if IDchaine == " ": CharChaine = "_"
	else : CharChaine = IDchaine
	NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
#	FichierPDB = open(NomFichierPDB,"w")
	
	#Ecrire le PDB
#	LignesPDB = []
#	NumAtom = [0]
#	for i in range(len(PartieProt)):
#		#print i
#		PartieProt[i].ResiduTOListOfString_PDB (NumAtom,IDchaine ,LignesPDB,altloc[i],NumRes=numDebPartieProt+i) 
#		#print stringList
#	LignesPDB.append("TER\n")
#	FichierPDB.writelines(LignesPDB)
	#print LignesPDB
	
	#Fermeture fichier PDB
#	FichierPDB.close()
	#print "PDB ouvert"
	
	if not path.exists(RepertoireSortieSEGNO):
		mkdir(RepertoireSortieSEGNO)
	#Lancement de SEGNO sur le fichier creer et recup des informations
	nomSortieSEGNO = RepertoireSortieSEGNO+"/"+NomProt+"_"+`model`+"_"+CharChaine+".seg"
	segno_file = NomProt+"_"+`model`+"_"+CharChaine+".seg"
	Lancer_SEGNO (NomFichierPDB, nomSortieSEGNO)
	#print "SEGNO fini"
	ListeInfoSEGNO = LectureSortieSEGNO (nomSortieSEGNO, IDchaine)
	if not RepertoireSortieSEGNO.split("/")[-1] == "temp_segno":
		cur_dir = getcwd()
		chdir(RepertoireSortieSEGNO)
		command = "tar cf - "+segno_file+"|"+"gzip -c >"+segno_file+".tar.gz"
		system(command)
		chdir(cur_dir)
		system("rm -f "+nomSortieSEGNO)
	else: system("rm -f "+nomSortieSEGNO)	
	#print " --> ListeInfoSEGNO" ,ListeInfoSEGNO
	
#	print ListeInfoSEGNO
	return ListeInfoSEGNO


	

# TEST ----------------------		
def main ():
	S1 = StructBuilder.StructBuilder("testPDB3.pdb")
	S1.Build_Chains()
	S1.Proteine.Chaines['A'].ModelsStruct[0].setMemoConformationsAlternatives_Ca()
	#LectureSortieSEGNO("testPDB3.segno")
	print S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA
	altloc = S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA[0][1]
	print "altloc",altloc
	
	seq_Struct= S1.Proteine.Chaines['A'].ModelsStruct[0].Seq_Struct
	Partie1 = []
	j = 0  #suivi des CA dans les listes de conformations alternatives (si besoin)
	PartieProt =0
	for i in range(len(seq_Struct)):
		if seq_Struct[i].__class__ == ResiduObj.Residu :
			Partie1.append(seq_Struct[i])
			j+= 1
		else:
			if j != 0:
				break
		
	AssignationSEGNO ("PDB3","A", Partie1 ,altloc, PartieProt+1, 1, 3,2, ".", ".")

if __name__ == "__main__":
	main()
