import math

__doc__="""Module pour l'assignation des blocs Proteiques"""



def DiffModulo360(angle1,angle2):
	"""Methode pour calculer la difference entre 2 angles modulo 360"""
	diff = math.fabs(angle1-angle2)
	if (diff>180.0) :return(math.fabs(diff-360.0))
	return(diff)



def CalculRMSDa (Frag1, Frag2):
	"""Calcul du RMSDa entre 2 listes d'angles diedres"""
	rmsda = 0.0
	#print "len(Frag1)",len(Frag1)
	for a1, a2 in zip(Frag1, Frag2):
		rmsda +=pow((DiffModulo360(a1,a2)),2)
	rmsda = math.sqrt(rmsda / len(Frag1))
	return rmsda


def Assignation_PBs (FragProt, altloc, nomFichierAnglesPBs):
	"""Methode pour l'assignation d'un fragment proteique en PBs, d'apres ses angles diedres Phi/Psi"""
	
	
	#Chargement des angles du fragment d'interet
	AnglesDiedresFragProt = []
	for i in range(len(FragProt)):
		if i == 0:
			anglePsi = FragProt[i].getAnglesPsi ( altloc[i])
			#print anglePsi #**
			AnglesDiedresFragProt.append(anglePsi )
			if anglePsi== 999: return 999 #Residu incomplet
		elif i == len(FragProt)-1:
			anglePhi =  FragProt[i].getAnglesPhi (altloc[i])
			AnglesDiedresFragProt.append(anglePhi)
			#print anglePhi #**
			if anglePhi==999: return 999 #Residu incomplet
		else :
			anglePsi = FragProt[i].getAnglesPsi (altloc[i])
			anglePhi = FragProt[i].getAnglesPhi (altloc[i])
			AnglesDiedresFragProt.append(anglePhi)
			AnglesDiedresFragProt.append(anglePsi )
			#print anglePhi #**
			#print anglePsi #**
			if anglePsi==999 or anglePhi==999: return 999 #Residu incomplet
	#print "AnglesDiedresFragProt \n",AnglesDiedresFragProt 
			
	#Chargement des angles de 16 PBs
	FichierAnglesPBs = open (nomFichierAnglesPBs, 'r')
	LignesFichierAnglesPBs = FichierAnglesPBs.readlines()
	FichierAnglesPBs.close()
	
	ListePBs = []
	for ligne in LignesFichierAnglesPBs:
		elements = ligne.split()
		float_elements = [float(elem) for elem in elements]
		ListePBs.append(float_elements)
	#print "ListePBs\n",ListePBs

	#Liste pour retenir les 16 rmsda et comparer ensuite
	ListeRMSDa = []
	
	
	#Parcours des 16 PBs et calcul du RMSDa
	#print AnglesDiedresFragProt 
	for pb in ListePBs :
		#print pb
		rmsda = CalculRMSDa (AnglesDiedresFragProt ,pb)
		ListeRMSDa.append(rmsda)
	
	#print "\t".join(["%7.3f"%(rmsda) for rmsda in ListeRMSDa])
	
	#Choix du PBs associe au plus petit RMSDa
	MinRMSDa = min(ListeRMSDa)
	IndexMinRMSDa = ListeRMSDa.index(MinRMSDa)#--> l'indice du plus petit RMSDa correspond au PBs gagnant !
	
	return IndexMinRMSDa
	
	
	

