from ctypes import *

import StructBuilder

__doc__ = """module destine a l'assignation de fragments de prot par les 120 prototypes (Benros)"""

TAILLE_STRUCT_PROTO = 11

	
def AssignationProto (FragProt,altloc,ListeProtos):# RepertoireProtos):
	"""Fonction pour l'assignation en Proto du fragment de sequence FragProt (liste de Residus). altloc est la liste permettant de connaitre la conformation alternative devant etre assignee"""
	
	#Chargement de la librairie libSuperposition_Zuker.so et de la fonction de comparaison de fragments
	Suplib = cdll.LoadLibrary("libSuperposition_Zuker.so")
#	RMSD=Suplib.Comp2ProtoRMSD #fonction
	RMSD=Suplib.Comp2FragRMSD 
	RMSD.restype=c_double #precision du type du retour
	TableauDouble33 = c_double * 33 #tableau de 33 doubles
	
	#Chargement des coordonnees du fragment d'interet
	#print "FragProt",len(FragProt)	
	#print "altloc", len(altloc)
	#print [res.Type for res in FragProt]
	#print [res.Backbone['CA'].Coord for res in FragProt]
	CoordFragInteret = TableauDouble33()
	for i  in range(len(FragProt)) :	
		#print '#',i
		#print FragProt[i].Type, FragProt[i].PositionDansSeq, FragProt[i].Backbone['CA'].Coord
		#print altloc[i]
		CoordFragInteret[i]=FragProt[i].Backbone['CA'].Coord[altloc[i]][0] #les X
		CoordFragInteret[i+TAILLE_STRUCT_PROTO ]=FragProt[i].Backbone['CA'].Coord[altloc[i]][1] #les Y
		CoordFragInteret[i+(TAILLE_STRUCT_PROTO*2)]=FragProt[i].Backbone['CA'].Coord[altloc[i]][2] #les Z
		
#	#Chargement des coordonnees des 120 protos
#	ListeProtos = []
#	for i in range(0,120):
#		#Lecture du PDB du proto
#		ProtoBuilder = StructBuilder.StructBuilder(RepertoireProtos+"/Proto_Pos"+str(i)+".pdb",verbose=0)
#		ProtoBuilder.Build_Chains(verbose=0)
#		Proto = ProtoBuilder.Proteine.Chaines['A'].ModelsStruct[0].Seq_Struct
#		ListeProtos.append(Proto)
	
	#Liste pour retenir les RMSD calcules avec les 120 protos
	ListeValRMSD = []
	
	#Parcours des prototypes pour calcules le RMSD entre eux et le frag d'interet
	for i in range(0,120):
		#Proto numero i
		Proto = ListeProtos[i]
		
		#Chargement des coordonnees du proto
		CoordProto = TableauDouble33()
		for i  in range(TAILLE_STRUCT_PROTO) :	
			CoordProto[i]=Proto[i].Backbone['CA'].Coord[0][0] #les X
			CoordProto[i+TAILLE_STRUCT_PROTO ]=Proto[i].Backbone['CA'].Coord[0][1] #les Y
			CoordProto[i+(TAILLE_STRUCT_PROTO*2)]=Proto[i].Backbone['CA'].Coord[0][2] #les Z
			
		#Calcul du RMSD
#		rmsd = RMSD(CoordFragInteret,CoordProto,0,TAILLE_STRUCT_PROTO)
		rmsd = RMSD(CoordFragInteret,CoordProto,TAILLE_STRUCT_PROTO)
		
		#Ajout a la liste des RMSDs
		ListeValRMSD.append(rmsd )
		
	#Selection du prototype correspondant au plus petit RMSD
	MinRMSD = min(ListeValRMSD)
	IndexMinRMSD = ListeValRMSD.index(MinRMSD ) #--> l'indice du plus petit RMSD correspond au proto gagnant !
	
	return IndexMinRMSD
	
			
			
			
			
			
