import re
#from os import popen
from os import system
from os import getcwd
from os import chdir
from os import mkdir
from os import pardir
from os import path	
import sys
import ResiduObj
import cPickle

__doc__ = """Module destine au calcul d'accessibilite par residu de proteines PDB parsees et enregistrees en cPickle avec naccess."""

ProgNACCESS = "naccess"

#-------------------------------------------------------------------------------------------------------------
# Erreur pour l'enregistrement des resultats naccess
class InfoNACCESSetEnregistrementDiff(Exception):
	def __init__(self,numRes, ResStruct, ResSelonNaccess):
		print >>sys.stderr, "Pour le meme numero %d, la structure a une %s et naccess met une %s"%(numRes, ResStruct,ResSelonNaccess)
#-------------------------------------------------------------------------------------------------------------




def Lancer_naccess (nomFichierPDB, repTemporaire):
	"""Methode pour lancer la commance naccess. Les fichiers crees sont mis dans le repertoire temp et s'appellent pdbXXXX.ent, .asa,.log,.rsa"""
	#On conserve en memoire le repertoire d'execution du programme global
	MemoRepertoireExecutionGlobale = getcwd()
	#On copie le pdb d'interet dans le repertoire temporaire sous un nom au format lisible par XTLSSTR
#	system("cp "+nomFichierPDB+" "+repTemporaire+"/pdbXXXX.ent")
	
	#system ("cat "+repTemporaire+"/pdbXXXX.ent")

	#On deplace l'execution dans le repertoire temporaire pour gere le changement de nom obligatoire des fichiers pdb et la creation de fichier automatique par naccess
	name_pdb = nomFichierPDB.split("/")[-1]
#	name_dummy = nomFichierPDB.split(".")[0]
#	name_file = name_dummy.split("/")[-1]
#	system("cp "+nomFichierPDB+" "+repTemporaire+"/")
#	chdir(repTemporaire)
	if not path.exists(repTemporaire):
		mkdir(repTemporaire)
	system("cp "+nomFichierPDB+" "+repTemporaire+"/")
        chdir(repTemporaire)
	#On lance xtlsstr
	commande = "%s -h %s > /dev/null"%(ProgNACCESS, name_pdb)
	system(commande)
	system("rm -f "+name_pdb)
	#system ("cat pdbXXXX.rsa")
#	system(command)	
	#On revient dans le repertoire principal d'execution
	chdir(MemoRepertoireExecutionGlobale)
	
	
	
def LectureSortieNACCESS (FichSortieNACCESS, chaine):
	"""Methode pour la lecture et la recuperation des infos donnees par NACCESS. Seul le .rsa est lu"""

	#Lecture de la sortie de naccess
	FichNaccess = open(FichSortieNACCESS,"r")
	LignesNaccess = FichNaccess.readlines()
	FichNaccess.close()
	
	#Recup des infos
	ListeNaccess = {}
	for ligne in LignesNaccess  :
			#print ligne
			if ligne[0:3] == "RES" and ligne[8] == chaine :
				Listeligne = []
				Listeligne.append(ligne[4:7]) #Nom du residu
				Listeligne.append(ligne[8]) #Nom de la chaine
				Listeligne.append(float(ligne[16:22])) #access absolue tout atomes
				Listeligne.append(float(ligne[23:28])) #access relative tout atomes
				Listeligne.append(float(ligne[29:35]))
				Listeligne.append(float(ligne[36:41]))
				Listeligne.append(float(ligne[42:48]))
				Listeligne.append(float(ligne[49:54]))
				ListeNaccess[ligne[9:14]] = Listeligne#Numero du residu dans le PDB fourni
			#print Listeligne
			
		
		
	return ListeNaccess
	


def Recup_AssignationNACCESS (NomProt,model, IDchaine, numAlt, RepertoirePDBPartieProt,repTemporaire, PDBcomplete = False):
	"""Methode pour lancer Naccess et recuperer les lignes d'accessibilite"""
        if IDchaine == " ": CharChaine = "_"
        else : CharChaine = IDchaine
	#Si on demande d'utiliser naccess uniquement sur les differentes parties du PDB
	if PDBcomplete == False : 
		#Nom du PDB de la partie de la prot donnee dans sa conformation desiree
		NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
		#print NomFichierPDB

	#Si au contraire on demande d'utiliser naccess sur le PDB entier
	else :	
		NomFichierPDB = RepertoirePDBPartieProt+"/"+"pdb"+NomProt+".ent"
		#RepertoirePDBPartieProt va dans ce cas,va correspondre au repertoire contenant les PDBs entiers (comme son nom ne l'indique pas :))
	name_pdb = NomProt+"_"+`model`+"_"+CharChaine
	#Lancement de naccess
	#print NomFichierPDB
	#print IDchaine
	Lancer_naccess  (NomFichierPDB, repTemporaire)
	#Lecture de la sortie de XTLSSTR et renvoie des lignes d'assignation
	if IDchaine=="_" : IDchaine = " "
	
	Info_naccess  = LectureSortieNACCESS (repTemporaire+"/"+name_pdb+".rsa",IDchaine)
	if not repTemporaire.split("/")[-1] == "temp_naccess":
		cur_dir = getcwd()
		chdir(repTemporaire+"/..")
		command = "tar cf - "+repTemporaire.split("/")[-1]+"|"+"gzip -c >"+repTemporaire.split("/")[-1]+".tar.gz"
		system(command)
		chdir(cur_dir)
		#system("rm -rf "+repTemporaire)
	else: system("rm -rf "+repTemporaire+"/*")

#	system("rm -rf "+repTemporaire+"/*")
#	Info_naccess  = LectureSortieNACCESS (repTemporaire+"/pdbXXXX.rsa",IDchaine)
#	system("rm -rf "+repTemporaire+"/pdbXXXX.*")
	return 	Info_naccess
	
	
	
	
def Modelset_AccessParRes_NACCESS (ObjetModele,NomPDB,IDchaine,RepertoirePDBPartieProt, repTemporaire , PDBcomplete = False):
	"""Methode permettant d'assigner temporairement la PREMIERE (max occupancy moyenne) conformation possible d'un modele residu par residu avec NACCESS.
	On renvoie 2 listes avec l'assignation de la sequence complete. La premiere donne l'accessibilite absolue, la seconde l'accessibilite relative.
	On efface finalement cette assignation temporaire."""
	dictGlobalNACCESS = {}
		
	
	if ObjetModele.ListeIndicesPartiesProt == None :
		ObjetModele.getIndicesDebFinPartie()
	listeIndicesDebFinPartie = ObjetModele.ListeIndicesPartiesProt 
	#print 	listeIndicesDebFinPartie
	
	if PDBcomplete == False :
		#Recuperation des assignations naccess de chaque Partie du modele
		for numPart in range(len(listeIndicesDebFinPartie)):
			dictGlobalNACCESS.update(Recup_AssignationNACCESS(NomPDB,IDchaine, 0, RepertoirePDBPartieProt,repTemporaire,numPart, listeIndicesDebFinPartie[numPart][0], listeIndicesDebFinPartie[numPart][1],PDBcomplete =PDBcomplete))
	else :
		system("rm -rf %s/%s"%(repTemporaire,NomPDB))		
		system ("touch %s/%s	"%(repTemporaire,NomPDB))
		for numPart in range(len(listeIndicesDebFinPartie)):
			system ("more %s >> %s/%s"%(RepertoirePDBPartieProt+"/"+NomPDB+"_Chaine"+IDchaine+"_Partie"+str(numPart)+"_Res"+str(listeIndicesDebFinPartie[numPart][0])+"-"+str(listeIndicesDebFinPartie[numPart][1])+"_Alt0.pdb",repTemporaire,NomPDB))
		dictGlobalNACCESS.update(Recup_AssignationNACCESS(NomPDB,IDchaine, 0, repTemporaire,repTemporaire,PDBcomplete =PDBcomplete))
		system("rm -rf %s/%s"%(repTemporaire,NomPDB))
	#print dictGlobalNACCESS
	
	#Parcours de la sequence globale
	numDepartPosDansSeq = ObjetModele.Seq_Struct[0].PositionDansSeq
	for i in range(len(ObjetModele.Seq_Struct)):
		res = ObjetModele.Seq_Struct[i]
		#print res.Type, res.PositionDansSeq,i
		

		#Si assignation naccess non disponible 
		if not dictGlobalNACCESS.has_key(i) :
			res.setAttributTEMP (-1.0)
		else :
			if res.Type == dictGlobalNACCESS[i][0] :
				#Enregistrement temporaire de l'assignation NACCESS
				res.setAttributTEMP (dictGlobalNACCESS[i][2]) #Access abs
				res.setAttributTEMP (dictGlobalNACCESS[i][3]) #Access rel
			else :
				raise InfoNACCESSetEnregistrementDiff(i,res.Type,dictGlobalNACCESS[i][0])
			
	
	
	#Recuperation de la liste global d'assignation
	assignationsNACCESSabs = [res.getAttributTEMP(0) for res in ObjetModele.Seq_Struct]
	assignationsNACCESSrel = [res.getAttributTEMP(1) for res in ObjetModele.Seq_Struct]
	#liberation de l'attribut temporaire
	[res.Del_AttributTEMP() for res in ObjetModele.Seq_Struct]
	
	return assignationsNACCESSabs, assignationsNACCESSrel 



# TEST ----------------------		
def main ():
	
	RepertoirePDBPartieProt = "PDBsClean_Parties"
#	RepertoirePDBPartieProt = "PDBsClean"
	repTemporaire = 'temp'
#	PDB ="pdb2b97.ent"
#	Chaine = "A"
#	PDB ="pdb2c49.ent"
#	Chaine = "A"
#	deb = "2"
#	fin = "2"
	#PDB ="pdb2cb5.ent"
	#Chaine = "B"
#	deb = "0"
#	fin = "452"
	PDB ="pdb1hzt.ent"
	Chaine = "A"
	
	fp = open("PDBsPickle/"+PDB,'r')
	prot = cPickle.load(fp)
	fp.close()
	print prot.Chaines[Chaine ].ModelsStruct[0].memoNombreConformationsALT_CA
	system("tar -zxf '"+RepertoirePDBPartieProt+"/"+PDB+"_Chaine"+Chaine+"_Mod"+'0'+".tgz' ")
	
#	#NomFichierPDB = RepertoirePDBPartieProt+"/"+PDB+"_Chaine"+Chaine+"_Partie"+"0"+"_Res"+deb+"-"+fin+"_Alt"+"0"+".pdb"
#	#print NomFichierPDB
	
#	#print prot.ProtTOString_PDB()

	print Modelset_AccessParRes_NACCESS (prot.Chaines[Chaine ].ModelsStruct[0] ,PDB,Chaine,RepertoirePDBPartieProt, repTemporaire, PDBcomplete =True )
	
	system("rm -rf "+RepertoirePDBPartieProt+"/*"+PDB+"*.pdb")	

if __name__ == "__main__":
	main()

