import re
from os import popen
from os import getcwd
from os import chdir
from os import system
import sys
import StructBuilder
import ResiduObj

__doc__ = """Module pour l'assignation d'un modele proteique en structure secondaire par DSSP"""

ProgDSSP = "dsspcmbi"
#ProgDSSP = "DSSPCMBI.EXE"


#-------------------------------------------------------------------------------------------------------------
class DSSPbreakDansPartieProt (Exception):
	def __init__(self ):
		print >>sys.stderr, "Dssp place un break au milieu d'une partie que mon parser a defini sans break !!"
#-------------------------------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------------------
class InfoDSSPetEnregistrementDiff (Exception):
	def __init__(self ):
		print >>sys.stderr, "Les infos donnees par DSSP sont differentes de celles enregitrees"
#-------------------------------------------------------------------------------------------------------------



def Lancer_DSSP (nomFichierPDB, nomSortieDSSP):
	"""Methode pour lancer la commance DSSP"""
	temp_dir = getcwd()
#	print ProgDSSP,nomFichierPDB, nomSortieDSSP
	commande = "%s '%s' '%s'  2> /dev/null"%(ProgDSSP,nomFichierPDB, nomSortieDSSP)
	popen(commande) 
	
	
	

def LectureSortieDSSP (nomSortieDSSP):
	"""Methode pour la lecture et la recuperation des infos donnees par DSSP"""

	ListeInfoDSSP = []
	flag_nofile = 0
	#Lecture de la sortie de dssp
	try: Fichdssp = open(nomSortieDSSP)
	except IOError, msg:
		print msg
		print "Secondary structure assignment by DSSP failed"
		flag_nofile = 1

	if flag_nofile != 1:
		Lignesdssp = Fichdssp.readlines()
		Fichdssp.close()
	
	#Recup des infos
		modeSII = 0
		for ligne in Lignesdssp :
#			if re.search("[0-9]+ [0-9]* [A-Z]? [A-Z]  [HBEGITS]?", ligne) != None:
#				print ligne
			if modeSII == 1:
#				Nomresidu = ligne[13]
#				if Nomresidu == "!":
#					raise DSSPbreakDansPartieProt
				#print ligne
				Listeligne = []
				#elements = ligne.split()
				Listeligne.append(ligne[11]) #Nom de la chaine
				Listeligne.append(ligne[13]) #Nom du residu
				Listeligne.append(ligne[16]) #SII
				Listeligne.append(float(ligne[97:103])) #angle Alpha
				Listeligne.append(float(ligne[103:109])) #angle Phi
				Listeligne.append(float(ligne[109:115])) #angle Psi
				Listeligne.append(float(ligne[116:122])) #Coord X
				Listeligne.append(float(ligne[123:129])) #Coord Y
				Listeligne.append(float(ligne[130:136])) #Coord Z
				if ligne[6:11] != '     ':	Listeligne.append(ligne[6:11]) #Numero du res dans le PDB fourni
				else :Listeligne.append(999) #pour les breaks dssp ne met pas de numero
				#print int(ligne[6:10])
				ListeInfoDSSP.append(Listeligne)
				#print Listeligne
				
			elif ligne[2] == "#": #Debut des annotations de SII tout au long de la sequence
				modeSII = 1
			
	return ListeInfoDSSP

def AssignationDSSP (NomProt,model , IDchaine, RepertoirePDBPartieProt, RepertoireSortieDSSP):
	"""Methode pour l'assignation en SII par DSSP pour chaque partie de la prot"""
	
	#print PartieProt
	
	#Ouvrir le PDB de la partie de la prot donnee dans sa conformation desiree
	if IDchaine == " ": CharChaine = "_"
	else : CharChaine = IDchaine
	NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
#	FichierPDB = open(NomFichierPDB,"w")
	
	#Ecrire le PDB
#	LignesPDB = []
#	NumAtom = [0]
#	for i in range(len(PartieProt)):
#		#print i
#		PartieProt[i].ResiduTOListOfString_PDB (NumAtom,IDchaine ,LignesPDB,altloc[i],NumRes=numDebPartieProt+i) 
#		#print stringList
#	LignesPDB.append("TER\n")
#	FichierPDB.writelines(LignesPDB)
	#print LignesPDB
	
	#Fermeture fichier PDB
#	FichierPDB.close()
	#print "PDB ouvert"
	
	#Lancement de DSSP sur le fichier creer et recup des informations
	nomSortieDSSP = RepertoireSortieDSSP+"/"+NomProt+"_"+`model`+"_"+CharChaine+".dssp"
	dssp_file = NomProt+"_"+`model`+"_"+CharChaine+".dssp"
	Lancer_DSSP (NomFichierPDB, nomSortieDSSP)
	#print "DSSP fini"
	ListeInfoDSSP = LectureSortieDSSP (nomSortieDSSP)
	if not RepertoireSortieDSSP.split("/")[-1] == "temp_dssp":
		cur_dir = getcwd()
		chdir(RepertoireSortieDSSP)
		command = "tar cf - "+dssp_file+"|"+"gzip -c >"+dssp_file+".tar.gz"
		system(command)
		chdir(cur_dir)
		system("rm -f "+nomSortieDSSP)
	else: system("rm -f "+nomSortieDSSP)	
	#print " --> ListeInfoDSSP" ,ListeInfoDSSP
	
	return ListeInfoDSSP


	

# TEST ----------------------		
def main ():
	S1 = StructBuilder.StructBuilder("testPDB3.pdb")
	S1.Build_Chains()
	S1.Proteine.Chaines['A'].ModelsStruct[0].setMemoConformationsAlternatives_Ca()
	#LectureSortieDSSP("testPDB3.dssp")
	print S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA
	altloc = S1.Proteine.Chaines['A'].ModelsStruct[0].memoConformationsALT_CA[0][1]
	print "altloc",altloc
	
	seq_Struct= S1.Proteine.Chaines['A'].ModelsStruct[0].Seq_Struct
	Partie1 = []
	j = 0  #suivi des CA dans les listes de conformations alternatives (si besoin)
	PartieProt =0
	for i in range(len(seq_Struct)):
		if seq_Struct[i].__class__ == ResiduObj.Residu :
			Partie1.append(seq_Struct[i])
			j+= 1
		else:
			if j != 0:
				break
		
	AssignationDSSP ("PDB3","A", Partie1 ,altloc, PartieProt+1, 1, 3,2, ".", ".")

if __name__ == "__main__":
	main()
