import re
from os import popen
from os import system
from os import getcwd
from os import chdir
from os import path
from os import mkdir
from os import pardir
import sys
import ResiduObj
import Definitions
import needle
import cPickle

__doc__ = """Module destine a l'assignation de SII par XTLSSTR de proteines PDB parsees et enregistrees en cPickle.
XTLSSTR peut donner 2 assignation pour un residu : seule la premiere est prise en compte"""

ProgXTLSSTR = "/home/lamarck/joseph/softwares/xtlsstr/XTLSSTR/xtlsstr"

#-------------------------------------------------------------------------------------------------------------
class InfoXTLSSTRetEnregistrementDiff (Exception):
	def __init__(self ):
		print >>sys.stderr, "Les infos donnees par XTLSSTR sont differentes de celles enregitrees"
#-------------------------------------------------------------------------------------------------------------

#-------------------------------------------------------------------------------------------------------------
class ProblemeLectureXTLSSTR  (Exception):
	def __init__(self ):
		print >>sys.stderr, "Probleme de lecture de la sortie de XTLSSTR"
#-------------------------------------------------------------------------------------------------------------

#def FormattagePDB (NomFichierPDB):
#	"""Fonction pour renumeroter les fichiers PDB a partir de 1."""
#	#Lecture
#	FichierPDB = open(NomFichierPDB,'r')
#	LignesPDB = FichierPDB.readlines()
#	FichierPDB.close()	
#	#print LignesPDB
#	
#	#Modif
#	NewLignes = []
#	for ligne in LignesPDB:
#		if ligne[0:4]=="ATOM":
#			numres = int(ligne[23:26])+1
#			ligne = "%s%4d%s"%(ligne[0:22],numres,ligne[26:])
#			print ligne
#			NewLignes.append(ligne)
#	
#	#Ecriture
#	FichierPDB = open(NomFichierPDB,'w')
#	FichierPDB.writelines(NewLignes)
#	FichierPDB.close()	

def Lancer_XTLSSTR (nomFichierPDB, repTemporaire):
	"""Methode pour lancer la commance XTLSSTR. Les fichiers crees sont mis dans le repertoire temp et s'appellent pdbXXXX.ent, .vtr,.ln,.cnt"""
	#On conserve en memoire le repertoire d'execution du programme global
	MemoRepertoireExecutionGlobale = getcwd()

	if not path.exists(repTemporaire):
		mkdir(repTemporaire)
#	print MemoRepertoireExecutionGlobale
	#On copie le pdb d'interet dans le repertoire temporaire sous un nom au format lisible par XTLSSTR
	system("cp "+nomFichierPDB+" "+repTemporaire+"/pdbXXXX.ent")
	#system ("cat "+repTemporaire+"/pdbXXXX.ent")

	#On deplace l'execution dans le repertoire temporaire pour gere le changement de nom obligatoire des fichiers pdb et la creation de fichier automatique par xtlsstr
	chdir(repTemporaire)
#	print repTemporaire
	#On lance xtlsstr
	commande = "echo 'pdbXXXX.ent' | %s > /dev/null"%(ProgXTLSSTR)
#	print commande
	popen(commande) 
	#system ("cat pdbXXXX.vtr")
	#On revient dans le repertoire principal d'execution
	chdir(MemoRepertoireExecutionGlobale)
	
	

def LectureSortieXTLSSTR (FichSortieXTLSSTR, line_output, SeqStruct, pos_seq):
	"""Methode pour la lecture et la recuperation des infos donnees par XTLSSTR. Le fichier lu est le .vtr.
	Attention aucun gap n'est autorise ici"""
	
	#Ouverture du fichier d'assignation
	try: SortieXTLSSTR = open(FichSortieXTLSSTR,'r')
	except IOError: print "cannot open xtlsstr output file"
	lignesSortieXTLSSTR = SortieXTLSSTR.readlines()
	SortieXTLSSTR.close()

	try: xtlsstr_ss = open(line_output, 'r')
	except IOError: print "cannot open xtlsstr output file"
	lines_xtlsstr = xtlsstr_ss.readlines()
	xtlsstr_ss.close()
	
	#Recup des infos
	ListeInfoXTLSSTR = {}
	SeqAA = ""
	SeqSII = ""
	seq_index = []
	flag_nogap = 0
	#-> Premiere lecture
	for ligne in lignesSortieXTLSSTR :
		#Residus mis de cote par XTLSSTR
#		if re.search("[0-9]+ *[A-Z]{1,3} *[A-Z]{3}",ligne):
#			#print ligne,
#			NumRes = int(ligne[12:16])
#			Res = Definitions.EquiAA_3to1lettres[ligne[7:10]]
#			if not ListeInfoXTLSSTR.has_key(NumRes) and NumRes == 0:	
#				ListeInfoXTLSSTR[NumRes] = ['#',Res ]

#		elif ligne[3:10] == "sec str":
		if ligne[3:10] == "sec str":
			SeqSII += re.sub(" ","",ligne[11:65])
		elif ligne[3:10] == "residue":
			SeqAA += re.sub(" ","",ligne[11:65])
#	print SeqAA
#	print SeqSII
	
	#Alignement pour verifier qu'on a toute la sequence de la partie
	AlignSeqAA,AlignSeqStruct = needle.Needle (SeqAA,SeqStruct)
#	print AlignSeqAA
#	print AlignSeqStruct
#	if "_" in AlignSeqAA :	

	for res in AlignSeqStruct:
		if res != "_":
			seq_index.append(res)
	if len(seq_index) != len(pos_seq):
		print "error while parsing xtlsstr output in the alignment format file!!!, using the line format file (.ln)"
#		print AlignSeqStruct
		flag_enter = 0
		for lines in lines_xtlsstr:
			if flag_enter == 1 and lines[0-3] == '   ':
				if lines[20] != ' ':
					ListeInfoXTLSSTR[lines[11-16]] = lines[20]
				else: ListeInfoXTLSSTR[lines[11-16]] = 'C' 
			if lines[0:4] == 'isub':
				flag_enter = 1
#		print ListeInfoXTLSSTR
			
	else:
		flag_nogap = 0
		for i in range(len(AlignSeqAA)):
			if AlignSeqStruct[i] != "_":
				if AlignSeqStruct[i] == AlignSeqAA[i]:
					for j in range(len(SeqAA)):
						if SeqAA[j] != "-":
							if int(pos_seq[flag_nogap][:-1]) == j+1 and AlignSeqAA[i] == SeqAA[j]:
								try :
									if re.search("[A-Z]", SeqSII[j]) != None:
										#print SeqSII[j]
										ListeInfoXTLSSTR[pos_seq[flag_nogap]] = SeqSII[j]
									else: ListeInfoXTLSSTR[pos_seq[flag_nogap]] = 'C'
								except IndexError: ListeInfoXTLSSTR[pos_seq[flag_nogap]] = 'C'
					if not ListeInfoXTLSSTR.has_key(pos_seq[flag_nogap]):
						ListeInfoXTLSSTR[pos_seq[flag_nogap]] = '#'
						print "could not assign xtlsstr sec str for %s"%(pos_seq[flag_nogap])
				else: ListeInfoXTLSSTR[pos_seq[flag_nogap]] = '#'
				flag_nogap += 1			
		
	#print "Avant remplissage entier",ListeInfoXTLSSTR
	
	#--> Remplissage Dico
#	if len(ListeInfoXTLSSTR) != 0:
#		deb = max(ListeInfoXTLSSTR.keys())+1 #+1 pour numeroter le residu QUI SUIT (je pars du principe que seul les premiers res peuvent avoir ete enregistres a ce niveau)
#	else :	
#		deb =debStruct 
#	if len(SeqSII) > 0 :
#	for i in range(len( SeqAA)):
#		if ListeInfoXTLSSTR.has_key(deb+i) :
#			raise ProblemeLectureXTLSSTR ()
#			print "problem parsing xtlsstr output!!!!"
#		else :
#			if i < len(SeqSII):
#				ListeInfoXTLSSTR[deb+i] = [SeqSII[i],SeqAA[i]]
#			else :
#				ListeInfoXTLSSTR[deb+i] = ['#',SeqAA[i]]
#	#print ListeInfoXTLSSTR
	return ListeInfoXTLSSTR
	
	
def Recup_AssignationXTLSSTR (NomProt,model, IDchaine, RepertoirePDBPartieProt,repTemporaire, seq_struct, pos_str):
	"""Methode pour lancer STRIDE et recuperer les lignes d'assgination"""
	
	#Nom du PDB de la partie de la prot donnee dans sa conformation desiree
	if IDchaine == " ": CharChaine = "_"
	else : CharChaine = IDchaine
	NomFichierPDB = RepertoirePDBPartieProt+"/"+NomProt+"_"+`model`+"_"+CharChaine+".pdb"
	#print NomFichierPDB
	
	#Lancement de XTLSSTR
	Lancer_XTLSSTR (NomFichierPDB, repTemporaire)
	xtl_vtr = repTemporaire+"/pdbXXXX.vtr"
	xtl_ln = repTemporaire+"/pdbXXXX.ln"	
	#Lecture de la sortie de XTLSSTR et renvoie des lignes d'assignation
	Info_XTLSSTR = LectureSortieXTLSSTR (xtl_vtr,xtl_ln,seq_struct,pos_str)
	if not repTemporaire.split("/")[-1] == "temp_xtlsstr":
		cur_dir = getcwd()
		chdir(repTemporaire+"/..")
                command = "tar cf - "+repTemporaire.split("/")[-1]+"|"+"gzip -c >"+repTemporaire.split("/")[-1]+".tar.gz"
                system(command)
		chdir(cur_dir)
		system("rm -rf "+repTemporaire)
	else: system("rm -rf "+repTemporaire+"/pdbXXXX.*")
	return 	Info_XTLSSTR


def Modelset_SIIParRes_XTLSSTR (ObjetModele,NomPDB,IDchaine,RepertoirePDBPartieProt, repTemporaire ):
	"""Methode permettant d'assigner temporairement la PREMIERE (max occupancy moyenne) conformation possible d'un modele residu par residu avec XTLSSTR.
	On renvoie une liste avec l'assignation de la sequence complete. 
	On efface finalement cette assignation temporaire."""
	dictGlobalXTLSSTR = {}
	#Recuperation des assignations XTLSSTR de chaque Partie du modele
	if ObjetModele.ListeIndicesPartiesProt == None :
		ObjetModele.getIndicesDebFinPartie()
	listeIndicesDebFinPartie = ObjetModele.ListeIndicesPartiesProt 
	Seq_Struct = "".join([Definitions.EquiAA_3to1lettres[res.Type] for res in ObjetModele.Seq_Struct])
	for numPart in range(len(listeIndicesDebFinPartie)):
		Seq_StructPart = Seq_Struct[listeIndicesDebFinPartie[numPart][0]:listeIndicesDebFinPartie[numPart][1]]
		#print Seq_Struct
		dictGlobalXTLSSTR.update(Recup_AssignationXTLSSTR (Seq_StructPart,NomPDB,IDchaine, numPart, listeIndicesDebFinPartie[numPart][0], listeIndicesDebFinPartie[numPart][1],0, RepertoirePDBPartieProt,repTemporaire))
	
	#print dictGlobalXTLSSTR
	
	#Parcours de la sequence globale
	for i in range(len(ObjetModele.Seq_Struct)):
		res = ObjetModele.Seq_Struct[i]
		
		#Si assignation Stride non disponible 
		if not dictGlobalXTLSSTR.has_key(i) :
			res.setAttributTEMP ("#")
		else :
			#Verification minimum : on verifie que le nom du residu correspond
			if Definitions.EquiAA_3to1lettres[res.Type] == dictGlobalXTLSSTR[i][1] :
				#Enregistrement temporaire de l'assignation XTLSSTR
				res.setAttributTEMP (dictGlobalXTLSSTR[i][0].upper())
			else :
				raise InfoXTLSSTRetEnregistrementDiff()
			
	
	
	#Recuperation de la liste global d'assignation
	assignationsXTLSSTR = [res.getAttributTEMP(0) for res in ObjetModele.Seq_Struct]
	#liberation de l'attribut temporaire
	[res.Del_AttributTEMP() for res in ObjetModele.Seq_Struct]
	
	return assignationsXTLSSTR


	
# TEST ----------------------		
def main ():
	
	RepertoirePDBPartieProt = "PDBsClean_Parties"
	repTemporaire = 'temp'
	PDB ="pdb2b97.ent"
	Chaine = "A"
#	PDB ="pdb2c49.ent"
#	Chaine = "A"
#	deb = "2"
#	fin = "2"
	PDB ="pdb2cb5.ent"
	Chaine = "B"
#	deb = "0"
#	fin = "452"
	
	fp = open("PDBsPickle/"+PDB,'r')
	prot = cPickle.load(fp)
	fp.close()
	print prot.Chaines[Chaine ].ModelsStruct[0].memoNombreConformationsALT_CA
	system("tar -zxf '"+RepertoirePDBPartieProt+"/"+PDB+"_Chaine"+Chaine+"_Mod"+'0'+".tgz' ")
	#NomFichierPDB = RepertoirePDBPartieProt+"/"+PDB+"_Chaine"+Chaine+"_Partie"+"0"+"_Res"+deb+"-"+fin+"_Alt"+"0"+".pdb"
	#print NomFichierPDB
	
	#Lancer_XTLSSTR (NomFichierPDB, "temp")
	#LectureSortieXTLSSTR ("temp/pdbXXXX.vtr")
	#print Recup_AssignationXTLSSTR (PDB,Chaine, 0,deb, fin,0, RepertoirePDBPartieProt ,"temp")
	print Modelset_SIIParRes_XTLSSTR (prot.Chaines[Chaine ].ModelsStruct[0] ,PDB,Chaine,RepertoirePDBPartieProt, repTemporaire)
	system("rm -rf "+RepertoirePDBPartieProt+"/*"+PDB+"*.pdb")	
	
	
	
if __name__ == "__main__":
	main()
	
