import sys
import Definitions

__doc__= """Module de definir un objet Atome"""

#-------------------------------------------------------------------------------------------------------------
class Atome :
	

	def __init__(self, TypeAtome):
		"""initialisation d'un objet atome"""
		self.Type = TypeAtome
		self.Coord = {} #si plusieurs positions : {0:,1:}
		self.Sigatm_Coord =  {} #si plusieurs positions : {0:,1:}
		self.AltLocation = 0  # nombre de positions alternatives : si 0 --> non, si 1 ou plus: oui
		self.Bfact = {}
		self.Sigatm_Bfact = {}
		self.Occupancy = {}
		self.Sigatm_Occupancy = {}
	
	def set_Coord(self, Liste_CoordXYZ):
		"""Initialisation du champ coord"""
		self.Coord[self.AltLocation]=Liste_CoordXYZ
		

	def set_Sigatm_Coord(self, Liste_sdCoordXYZ):
		"""Initialisation du champ Sigatm_coord"""
		self.Sigatm_Coord[self.AltLocation]=Liste_sdCoordXYZ
		

	def set_Bfact (self, Bfacteur):
		"""Initialisation du champ Bfacteur"""
		self.Bfact[self.AltLocation]=Bfacteur
		
	def set_Sigatm_Bfact (self, sdBfacteur):
		"""Initialisation du champ Bfacteur"""
		self.Sigatm_Bfact[self.AltLocation]=sdBfacteur

	def set_Occupancy (self, Occupancy):
		"""Initialisation du champ Bfacteur"""
		self.Occupancy[self.AltLocation]=Occupancy
		
	def set_Sigatm_Occupancy (self, sdOccupancy):
		"""Initialisation du champ Bfacteur"""
		self.Sigatm_Occupancy[self.AltLocation]=sdOccupancy


	def AtomTOListOfString (self,stringList=[] ): 
		"""Format d'impression : ['CA 0 42.898 2.967 102.161 33.870\t\n',  ...]"""
		string=""
		for pos in range(len(self.Coord)):
			X= self.Coord[pos][0]
			Y= self.Coord[pos][1]
			Z= self.Coord[pos][2]
			#print X,Y,Z,self.Bfact  #***
			string+="%s %d %3.3f %3.3f %3.3f %3.3f\t"%(self.Type,self.AltLocation,X,Y,Z,self.Bfact[pos])
		string= string + "\n"
		stringList.append(string)
		#print stringList #**
		

	def AtomTOListOfString_PDB (self, NumAtom, InfoResidu,InfoChaine, stringList=[] ,altloc=None): 
	#InfoResidu[0] : Nom du residu, InfoResidu[1]:position dans la seq, InfoChaine : IdChaine
		"""Format d'impression PDB pour les atomes"""
		LETTERS=['A','B','C']
		NumAtom[0] = NumAtom[0]+1
		string=""
		if altloc == None :
			for pos in range(len(self.Coord)):
				X= self.Coord[pos][0]
				Y= self.Coord[pos][1]
				Z= self.Coord[pos][2]
				Bfacteur = self.Bfact[pos]
				Occ = self.Occupancy[pos]
				if pos > 0:
					NumAtom[0] = NumAtom[0]+1
				#print X,Y,Z,self.Bfact  #***
				if len(self.Coord) > 1:
					if InfoResidu[0] in Definitions.AA_standard:
						string="ATOM  %5d  %-3s%s%3s %s%4s    %8.3f%8.3f%8.3f%6.2f%6.2f          %2s \n"%(NumAtom[0],self.Type,LETTERS[pos],InfoResidu[0],InfoChaine,InfoResidu[1],X,Y,Z,Occ, Bfacteur ,self.Type[0])
					else:
						string="HETATM%5d  %-3s%s%3s %s%4s    %8.3f%8.3f%8.3f%6.2f%6.2f          %2s \n"%(NumAtom[0],self.Type,LETTERS[pos],InfoResidu[0],InfoChaine,InfoResidu[1],X,Y,Z,Occ, Bfacteur ,self.Type[0])
				#string= string + "\n"
				else:
                                        if InfoResidu[0] in Definitions.AA_standard:
                                                string="ATOM  %5d  %-3s%s%3s %s%4s    %8.3f%8.3f%8.3f%6.2f%6.2f          %2s \n"%(NumAtom[0],self.Type,' ',InfoResidu[0],InfoChaine,InfoResidu[1],X,Y,Z,Occ, Bfacteur ,self.Type[0])
                                        else:
                                                string="HETATM%5d  %-3s%s%3s %s%4s    %8.3f%8.3f%8.3f%6.2f%6.2f          %2s \n"%(NumAtom[0],self.Type,' ',InfoResidu[0],InfoChaine,InfoResidu[1],X,Y,Z,Occ, Bfacteur ,self.Type[0])
#				print string
				stringList.append(string)
			#print stringList #**
		else:
			if len(self.Coord) > 1: #Altloc definitif en fonction de ce qui a ete enregistre pour l'atome
				altlocDef = altloc
			else: #le altloc etant suceptible d'etre passe par residu: il possible que tous les atomes de ce residu n'ai pas une position alternative
				altlocDef = 0
			
			X= self.Coord[altlocDef][0]
			Y= self.Coord[altlocDef][1]
			Z= self.Coord[altlocDef][2]
			Bfacteur = self.Bfact[altlocDef]
			Occ = self.Occupancy[altlocDef]
			#print X,Y,Z,self.Bfact  #***
			string="ATOM  %5d  %-3s%s%3s %s%4s    %8.3f%8.3f%8.3f%6.2f%6.2f          %2s \n"%(NumAtom[0],self.Type,' ',InfoResidu[0],InfoChaine,InfoResidu[1],X,Y,Z,Occ, Bfacteur ,self.Type[0])
			#Aucune lettre n'est note pour altloc car sinon dssp n'accepte pas les differentes combinaisons non reportees sur les N,C ET CA ... Dommage !!
			#string= string + "\n"
			stringList.append(string)



	
