
__doc__="""Module permettant de definir les chaines de caracteres utilisees dans les PDBs"""

#AA_standard = [ALA", "CYS", "ASP", "THR", "VAL", "TRP", "TYR", "GLU", "PHE", "GLY", "HIS", "ILE", "LYS", "LEU", "MET", "ASN", "PRO", "GLN", "ARG", "SER", "GLX","ASX","PCA","GL3","AGM", "SMC","OCS","MHS","HYP", "KCX","SMC","MME","CSE","MEN","TRW","FME","CEA","CSS","CSD","TQQ","DHA"]

AA_standard = ["ALA", "CYS", "ASP", "THR", "VAL", "TRP", "TYR", "GLU", "PHE", "GLY", "HIS", "ILE", "LYS", "LEU", "MET", "ASN", "PRO", "GLN", "ARG", "SER","GLX","ASX", "CSE"]


# Les acides amines en code 3 lettres
AA_3Lettres = ["ALA", "CYS", "ASP", "THR", "VAL", "TRP", "TYR", "GLU", "PHE", "GLY", "HIS", "ILE", "LYS", "LEU", "MET", "ASN", "PRO", "GLN", "ARG", "SER","GLX","ASX",\
		"PCA","GL3","AGM", "SMC","OCS","MHS","HYP", "KCX","SMC","MME","CSE","MEN","TRW","FME","CEA","CSS","CSD","TQQ","DHA", 'BCS', 'PG9', 'GT9', 'MLY', 'AMU', 'API', 'QUI', 'CH3', 'HQU', 'CPC', 'PTR', 'DIP', 'FTY', 'PTH', 'DPN', 'NPH', 'DIX', 'DIY', 'CME', 'TYS', 'PYX', 'MIS', 'BUC', 'TPQ', 'PSE', 'ABA', 'EFC', 'C6C', 'C5C', 'BIC', 'CSP', 'MSE', 'THC', 'SET', 'DVA', 'DPR', 'SAR', 'MVA', 'CTH', 'POM', 'MAA', 'H5M', 'HMI', 'BNN', 'PHQ', 'TBG', 'HV8', 'HV7', 'LLP', 'NLE', 'CYG', 'HMR', 'SIN', 'CGU', 'SCH', 'HMA', 'DLE', 'FBA', 'AYA', 'PLP', 'AIB', 'CXM', 'DAL', 'FOR', 'ETA', 'TRN', 'PHL', 'DAS', 'IVA', 'LTA', 'STA', 'DFO', 'NME', 'DFI', 'ILG', 'PBB', 'TNB', 'SNN', 'ACY', 'IAS', 'SLE', 'KPH', 'FGL', 'THX', 'BHD', 'MAI', 'SBL', 'CLD', 'PYR', 'MDH', 'ACB', 'HMF', 'SAC', 'ALN', 'CDE', 'HPE', 'ORN', 'ALC', 'SEP', 'DAB', 'BCC', 'DPP', 'CSB', 'NVA', 'HTR', 'SVA', 'CRO', 'GMA', 'SME', 'BMT', 'MLE', 'DSY', 'TIH', 'IGL', 'IIC', 'LML', 'DGN', 'DAR', 'DSN', '1PA', 'CAS', 'MTY', 'TPO', 'SLZ', 'YRR', ' DG', 'BOC', 'BLY', 'SNC', 'DFT', 'FOE', 'AHO', 'FLT', 'AEA', 'HIC', 'CSW', 'DTY', 'DLY', 'DGL', 'DIL', 'DCY', 'CYQ', 'SEB', 'IYR', 'PPH', 'ABU', 'EMR', 'GPL', 'GLZ', 'ASK', 'CBG', 'S02', 'EPO', 'MGG', 'ACL', 'ARM', 'DMT', 'MNL', 'PM3', 'DSE', 'TBM', 'MNV', 'MSA', 'TMD', 'MHL', 'IML', 'VAD', 'CSO', 'PHI', 'NOR', 'DHI', 'DTR', 'CY1', 'CLE', 'PHD', 'HAQ', 'SEL', 'ODA', 'MPQ', 'BUG', 'TYQ', 'TYY', 'CY3', 'DCL', '3DR', '3AH', 'MYR', '2PP', 'NRI', 'NP3', 'ASI', 'PCS', 'DIV', 'SCY', 'CMT', 'AR2', '1LU', 'AFA', 'AHB', 'GHP', 'D4P', 'SHP', 'CHP', 'CCS', 'NLN', 'CSA', 'FKI', 'CYF', 'NEP', 'HPH', 'MSO', 'ALY', 'GLH', 'BAL', 'CHS', 'NSP', 'MRM', 'HFA', 'CPY', 'PCH', 'OMT', 'PYT', 'DBY', 'OAS', 'TPL', 'FOG', 'MBZ', 'PBF', 'APP', 'CPI', 'TLX', 'MHO', 'TFA', 'ISO', 'ANI', 'CSY', 'CSH', 'ASU', 'CCY', 'PTA', 'DCI', 'DOA', 'PSA', 'MOR', 'CHF', 'DPH', 'MPR', 'APH', 'PIP', 'ADD', 'DAM', 'HPQ', 'CR2', 'PN2', 'CSX', '3PA', '4BA', 'CSU', 'ARO', 'CSZ', 'ODS', 'NFP', 'CAB', 'LOL', 'ALQ', 'PS0', 'ALS', 'DLS', 'S1H', 'PYP', 'PYY', 'TRO', '9AC', '2MR', 'AAB', 'CRQ', 'TYB', 'B2A', 'BLE', 'B2F', 'LYN', 'SUI', 'LOV', 'SEC', '1AB', 'SHC', 'TRJ', 'FRF', 'MEA', 'HSO', 'PIA', 'MGN', 'PAA', 'PYA', 'ALG', 'ALO', 'NOA', 'CAV', 'APY', 'FAG', 'MSU', 'ALM', 'PED', 'CAF', 'OPN', 'CGN', 'FTR', 'PAT', 'ASA', 'PTL', 'FBE', 'ACA', 'M3L', 'MLZ', 'QNC', 'CPV', 'NPT', 'DAH', 'SDP', 'AHP', 'BCX', 'BFD', 'CZZ', 'HSE', 'HOA', 'HIP', 'DPY', 'DRP', 'TRQ', 'PR0', 'RHS', 'DMH', '143', 'MAZ', 'PTM', 'CSR', 'MPT', 'CLG', 'CLH', 'NIY', 'ESD', 'ILX', 'TRX', 'ESC', 'PHA', 'CSI', 'PDI', 'GLM', 'IIL', 'CRG', 'YCM', 'TYI', 'HPD', 'PXZ', 'MDP', 'NIT', 'TYT', 'PO0', 'LYX', 'VOL', 'DDX', 'DRZ', 'CY4', 'BZP', 'BP4', 'PEA', 'AA4', 'TEE', 'NC1', 'PG1', 'MC1', 'FGP', 'TYN', 'KI2', 'ACE', 'DMK', 'DNL', 'MN7', 'MN2', 'MN1', 'MN8', 'HTI', 'SMF', 'MCL', 'LEF', 'FCL', 'PFF', 'LCX', 'P2Y', '2DF', 'BOR', 'DCZ', 'CYD', '5CS', 'NYC', '4IN', '5ZA', 'B2V', 'B2I', 'BNO', 'PVA', 'LAC', 'UMA', 'PHM', 'IPN', 'HMB', 'VAF', 'APM', 'PLE', 'OPH', 'ETO', 'XAO', 'DPL', 'LYZ', 'NCB', 'DHL', 'ASB', 'AA6', 'TRF', 'CR5', 'LAL', 'GMU', 'DNE', 'DNM', '4FW', '4F3', '32S', '32T', '23S', 'HLU', 'YOF', 'MFC', '4HT', 'GHG', 'AR4', 'DNG', 'NLO', 'LYM', 'CR0', 'PRS', '2MT', 'APE', 'MBQ', 'NBQ', 'ORP', 'CZ2', 'NAL', 'PIV', 'LPL', 'DBZ', 'THO', 'MEU', 'PAQ', 'OXX', 'MEG', 'KYN', 'DSG', '175', 'AHT', 'CLT', 'DDE', '2BU', '2BD', 'AP7', 'SOC', 'LLY', 'OPR', 'NRQ', 'MOP', 'HIA', 'PYC', 'ALT', '23F', 'APK', 'CLB', 'OCY', 'MDO', 'VLL', '3MD', 'VDL', 'TCQ', 'TYZ', '3TY', '2OP', 'DBU', ' D3', 'CMH', 'BTR', 'GTH', 'NZH', 'HSL', 'CH6', 'CH7', 'NFA', 'CRK', 'DYG', 'LME', 'IAM', 'HHK', 'OHS', 'CRX', 'CRW', 'OSE', 'PPN', 'BIF', 'CRU', 'BE2', 'BBC', 'BPE', 'AAR', 'R1F', 'CR8', 'R1B', 'R1A', 'CR7', 'R7A', 'CYR', 'AZK', 'FLE', '6CL', 'OLT', '6CW', 'TYC', 'PR3', 'P1L', 'FHL', 'CYJ', 'LET', 'OBS', 'LSO', 'C1X', 'AB7', 'KOR', 'SCS', '1TY', '2TY', 'TTS', 'AKL', 'GYS', 'TOX', 'OTY', 'NAM', 'XYG', 'XXY', 'ORQ', 'C12', 'CWR', 'HY3', 'CQR', 'RC7', 'GYC', 'LPD', 'C99', 'X9Q', 'CLV', 'TYO', 'AYG', 'TTQ', '1TQ', 'MLL', 'QLG', 'LDH', '4DP', 'HIQ', 'LED', 'SOY', 'AME', 'LYR', 'SC2', 'CY0', 'VME', 'AGT', 'SUN', 'MCS', 'SGR', 'SXE', 'SGB', 'SVX', 'SVY', 'SVV', 'SVZ', 'SBG', 'CY7', 'ZHP', 'PF5', 'RCY', 'DTH', 'M2L', 'ASL', '0CS', 'NYG', 'KGC', 'CS1', 'XX1', 'CS3', 'CS4', 'B3K', 'B3D', 'B3E', 'B3S', 'B3Y', 'B3X', 'B3A', 'M0H', 'TYX', 'N10', '4FB', 'KST', 'OHI', 'DYS', 'NYS', 'PSH', 'SAH', 'BG1', 'CML', '2ML', 'IPG', 'GVL', 'LYP', 'C3Y', 'NMM', 'DA2', 'HRG', 'PRQ', 'TY3', 'TY2', 'A0A', 'IEY', 'TH5', 'DTG', 'ASM', 'DPQ', 'ESB', 'CFY', 'TCR', 'FRD', 'CIR', 'LNT', 'IT1', 'SYS', '4PH', 'KYQ', 'ML3', 'LCK', 'LA2', 'FZN', 'SIC', 'BIU', 'CAL', 'RNG', 'AHH', 'NMC', 'SBD', 'AEI', 'BNA', 'CHG', 'OME', 'AHS', 'PEC', 'PGL', 'PRR', 'CUC']


#Les aa modifies en code 3 lettres 
ResiModif_3lettres = ["PCA","GL3","AGM", "SMC","OCS","MHS","HYP", "KCX","SMC","MME","CSE","MEN","TRW","FME","CEA","CSS","CSD","TQQ","DHA", 'BCS', 'PG9', 'GT9', 'MLY', 'API', 'PTR', 'FTY', 'PTH', 'DPN', 'NPH', 'CME', 'TYS', 'PYX', 'MIS', 'BUC', 'TPQ', 'ABA', 'EFC', 'C6C', 'C5C', 'CSP', 'MSE', 'THC', 'SET', 'DVA', 'DPR', 'SAR', 'MVA', 'CTH', 'POM', 'MAA', 'H5M', 'BNN', 'TBG', 'LLP', 'NLE', 'CYG', 'HMR', 'CGU', 'SCH', 'DLE', 'AYA', 'AIB', 'CXM', 'DAL', 'TRN', 'PHL', 'DAS', 'ILG', 'PBB', 'TNB', 'IAS', 'FGL', 'BHD', 'MAI', 'SBL', 'CLD', 'PYR', 'ACB', 'HMF', 'SAC', 'ALN', 'HPE', 'ORN', 'ALC', 'SEP', 'DAB', 'DPP', 'CSB', 'NVA', 'HTR', 'SVA', 'CRO', 'GMA', 'SME', 'BMT', 'MLE', 'TIH', 'IGL', 'DGN', 'DAR', 'DSN', '1PA', 'CAS', 'MTY', 'TPO', 'SLZ', 'BLY', 'SNC', 'FOE', 'AHO', 'FLT', 'HIC', 'CSW', 'DTY', 'DLY', 'DGL', 'DIL', 'DCY', 'CYQ', 'SEB', 'IYR', 'PPH', 'GPL', 'GLZ', 'ASK', 'MGG', 'ACL', 'ARM', 'MNL', 'PM3', 'DSE', 'TBM', 'MNV', 'MSA', 'TMD', 'MHL', 'IML', 'VAD', 'CSO', 'PHI', 'DHI', 'DTR', 'CY1', 'CLE', 'PHD', 'SEL', 'MPQ', 'BUG', 'TYQ', 'TYY', 'CY3', '3AH', 'ASI', 'PCS', 'DIV', 'SCY', 'CMT', 'AR2', '1LU', 'DCL', 'AFA', 'AHB', 'GHP', 'SHP', 'CHP', 'CCS', 'NLN', 'CSA', 'CYF', 'NEP', 'HPH', 'MSO', 'ALY', 'GLH', 'BAL', 'CHS', 'OMT', 'PYT', 'DBY', 'OAS', 'TPL', 'FOG', 'PBF', 'MHO', 'CSY', 'PSA', 'HPQ', 'CR2', 'CSX', 'CSU', 'ARO', 'CSZ', 'CAB', 'DAM', 'ALS', 'DLS', 'S1H', 'TRO', '2MR', 'CRQ', 'TYB', 'B2A', 'BLE', 'B2F', 'LYN', 'SUI', 'SEC', '1AB', 'SHC', 'FRF', 'MEA', 'HSO', 'PIA', 'MGN', 'PYA', 'ALG', 'ALO', 'ALM', 'CAF', 'FTR', 'PAT', 'ASA', 'M3L', 'MLZ', 'DAH', 'SDP', 'AHP', 'BCX', 'BFD', 'CZZ', 'HSE', 'SNN', 'ACY', 'HIP', 'TRQ', 'FOR', 'DMH', '143', 'PTM', 'CSR', 'CLG', 'CLH', 'NIY', 'ILX', 'TRX', 'ESC', 'PHA', 'CSI', 'IIL', 'YCM', 'TYI', 'TYT', 'LYX', 'CY4', 'AA4', 'TEE', 'NC1', 'PG1', 'MC1', 'FGP', 'TYN', 'DMK', 'DNL', 'HTI', 'SMF', 'MCL', 'DPH', 'LEF', 'FCL', 'PFF', 'LCX', 'P2Y', 'BOR', 'CYD', '5CS', '4IN', 'B2V', 'B2I', 'UMA', 'PHM', 'APH', 'VAF', 'PLE', 'DPL', 'LYZ', 'NCB', 'DHL', 'ASB', 'TRF', 'CR5', 'LAL', 'DNE', 'DNM', '4FW', '4F3', '32S', '32T', '23S', 'HLU', 'YOF', 'MFC', '4HT', 'GHG', 'AR4', 'DNG', 'NLO', 'LYM', 'CR0', 'PRS', '2MT', 'MBQ', 'NBQ', 'CZ2', 'NAL', 'DBZ', 'MEU', 'PAQ', 'OXX', 'MEG', 'KYN', 'DSG', '175', 'DDE', 'SOC', 'LLY', 'OPR', 'NRQ', 'HIA', 'PYC', 'ALT', '23F', 'APK', 'CLB', 'OCY', 'MDO', 'VLL', '3MD', 'VDL', 'TCQ', 'TYZ', '3TY', 'DBU', 'CMH', 'BTR', 'NZH', 'HSL', 'CH6', 'CH7', 'NFA', 'CRK', 'DYG', 'LME', 'IAM', 'HHK', 'OHS', 'CRX', 'CRW', 'OSE', 'PPN', 'BIF', 'CRU', 'BBC', 'BPE', 'AAR', 'R1F', 'CR8', 'R1B', 'R1A', 'CR7', 'R7A', 'CYR', 'AZK', 'FLE', '6CL', 'OLT', '6CW', 'TYC', 'PR3', 'P1L', 'FHL', 'CYJ', 'LET', 'OBS', 'LSO', 'C1X', 'AB7', 'KOR', 'SCS', '1TY', '2TY', 'TTS', 'AKL', 'GYS', 'TOX', 'OTY', 'NAM', 'XYG', 'XXY', 'ORQ', 'C12', 'CWR', 'HY3', 'CQR', 'RC7', 'GYC', 'LPD', 'C99', 'X9Q', 'CLV', 'TYO', 'AYG', 'TTQ', '1TQ', 'MLL', 'QLG', 'LDH', '4DP', 'HIQ', 'LED', 'SOY', 'AME', 'LYR', 'SC2', 'CY0', 'VME', 'AGT', 'SUN', 'MCS', 'SGR', 'SXE', 'SGB', 'SVX', 'SVY', 'SVV', 'SVZ', 'SBG', 'CY7', 'PF5', 'RCY', 'DTH', 'M2L', 'ASL', '0CS', 'NYG', 'KGC', 'CS1', 'XX1', 'CS3', 'CS4', 'B3K', 'B3D', 'B3E', 'B3S', 'B3Y', 'B3X', 'B3A', 'M0H', 'TYX', 'N10', 'NYC', '4FB', 'KST', 'OHI', 'DYS', 'NYS', 'PSH', 'SAH', 'BG1', 'CML', '2ML', 'IPG', 'GVL', 'LYP', 'C3Y', 'NMM', 'DA2', 'HRG', 'PRQ', 'TY3', 'TY2', 'A0A', 'IEY', 'TH5', 'DPQ', 'ESB', 'CFY', 'CIR', 'LNT', 'IT1', 'SYS', '4PH', 'KYQ', 'ML3', 'LCK', 'LA2', 'FZN', 'SIC', 'BIU', 'NMC', 'SBD', 'AEI', 'CHG', 'PEC', 'PRR']

#Equivalence code une lettre/3lettres pour les aa
EquiAA_3to1lettres = {"ALA":'A', "CYS":'C', "ASP":'D', "THR":'T', "VAL":'V', "TRP":'W', "TYR":'Y', "GLU":'E', "PHE":'F', "GLY":'G', "HIS":'H',\
			"ILE":'I', "LYS":'K', "LEU":'L', "MET":'M', "ASN":'N', "PRO":'P', "GLN":'Q', "ARG":'R', "SER":'S',"GLX":'Z',"ASX":'B', 'MHS':'H', "PCA":'Q',\
			"GL3":'G',"AGM":'R', "SMC":'C',"OCS":'C',"HYP":'P', "KCX":"K","SMC":'C',"MME":'M',"CSE":'C',"MEN":'N',"TRW":'W',"FME":'M',\
			"CEA":'C',"CSS":'C',"CSD":'C',"TQQ":'W',"DHA":"A", 'CPI': 'X', 'PAQ': 'Y', 'B2V': 'V', 'CPC': 'X', 'SIC': 'D', 'CPY': 'X', 'PTA': 'X', 'B2I': 'I', 'B2F': 'F', 'AGT': 'C', 'SIN': 'X', 'NP3': 'X', 'KYN': 'A', 'R1A': 'C', '0CS': 'A', 'NYS': 'C', 'SCY': 'C', 'KYQ': 'K', 'VAF': 'V', 'VAD': 'A', 'AHB': 'R', 'SNC': 'C', 'SNN': 'X', 'OSE': 'S', 'AHH': 'X', 'MAZ': 'X', 'AHO': 'A', 'LAC': 'X', 'MAA': 'A', 'AHS': 'X', 'AHP': 'A', 'NLO': 'L', 'AHT': 'X', 'XYG': 'D', 'MAI': 'R', 'NPT': 'X', 'DTH': 'T', 'CMH': 'C', 'PCS': 'F', 'CME': 'C', 'DTG': 'X', '1TY': 'Y', 'PCH': 'X', 'NYC': 'X', 'DTR': 'W', 'CMT': 'C', 'B3Y': 'Y', 'VLL': 'V', 'TTS': 'Y', 'LSO': 'K', 'TTQ': 'W', 'CHG': 'A', 'NYG': 'N', 'M2L': 'K', 'CPV': 'X', 'FTR': 'W', 'BLY': 'K', 'RHS': 'X', 'NFA': 'F', 'DSY': 'X', 'FTY': 'Y', 'P1L': 'C', 'DSN': 'S', 'NFP': 'X', 'KPH': 'X', 'DSG': 'N', 'IGL': 'G', 'CBG': 'X', 'HLU': 'L', 'HSE': 'S', 'NOA': 'X', 'LME': 'E', 'BE2': 'X', 'NOR': 'X', 'GLH': 'Q', '5CS': 'C', 'GLM': 'X', 'BZP': 'X', 'DOA': 'X', 'B3D': 'D', 'GLZ': 'G', 'AKL': 'D', 'SMF': 'F', 'SME': 'M', 'CTH': 'T', 'DLY': 'K', 'CS3': 'C', 'MDH': 'X', 'MDO': 'A', ' DG': 'X', 'B3A': 'A', 'MDP': 'X', 'FCL': 'F', 'R7A': 'C', 'CAL': 'X', 'DFT': 'X', 'MVA': 'V', 'DFO': 'X', 'DFI': 'X', ' D3': 'X', 'ALN': 'A', 'ALO': 'T', 'ALM': 'A', 'ALG': 'R', 'ALC': 'A', 'ORP': 'X', 'ORQ': 'R', 'ORN': 'A', 'LML': 'X', 'SBG': 'S', 'SBD': 'S', 'ALY': 'K', 'QUI': 'X', 'DIX': 'X', 'ALT': 'A', 'GYS': 'S', 'ALS': 'A', 'SBL': 'S', 'ALQ': 'X', 'IAM': 'A', 'TOX': 'W', 'DPR': 'P', 'DPQ': 'Y', 'DPP': 'A', 'CAS': 'C', 'NC1': 'S', 'B2A': 'A', 'PN2': 'X', 'CAV': 'X', 'DPY': 'X', 'CAB': 'A', 'DPN': 'F', 'BAL': 'A', 'DPL': 'P', 'CAF': 'C', 'DPH': 'X', 'HIP': 'H', 'HIQ': 'H', 'KOR': 'C', 'PGL': 'X', '4IN': 'W', 'DYS': 'C', 'HIA': 'H', 'HIC': 'H', 'IIC': 'X', 'AB7': 'E', 'C5C': 'C', 'D4P': 'X', '9AC': 'X', 'ABA': 'A', '143': 'C', 'ABU': 'X', 'PG1': 'S', 'NZH': 'H', 'AZK': 'K', 'PG9': 'G', '3MD': 'D', '23F': 'F', 'TFA': 'X', 'BHD': 'D', '1AB': 'P', 'QLG': 'Q', 'NCB': 'A', 'A0A': 'D', '23S': 'W', 'GHP': 'G', 'AP7': 'X', 'GHG': 'Q', 'SLZ': 'K', 'MIS': 'S', 'TY2': 'Y', 'TY3': 'Y', 'SAH': 'C', 'SAC': 'S', 'FGP': 'S', '4PH': 'F', 'FGL': 'G', 'CH3': 'X', 'PRQ': 'F', 'PRS': 'P', 'CH7': 'K', 'SAR': 'G', '4F3': 'G', 'LAL': 'A', 'CHF': 'X', 'BFD': 'D', 'TPO': 'T', 'H5M': 'P', 'AYG': 'A', 'TPL': 'W', 'AYA': 'A', '4FB': 'P', 'CHP': 'G', 'MRM': 'X', 'CHS': 'F', 'PR0': 'X', 'TPQ': 'Y', 'IIL': 'I', '4FW': 'W', 'LPD': 'P', 'NPH': 'C', 'PYX': 'C', 'PYY': 'X', 'TYN': 'Y', 'APY': 'X', 'TYI': 'Y', 'PYP': 'X', 'PYR': 'S', 'PYT': 'A', 'TYB': 'Y', 'MBQ': 'Y', 'DBY': 'Y', 'APK': 'K', 'APH': 'X', 'API': 'K', 'TYX': 'C', 'TYY': 'Y', 'TYZ': 'R', 'APM': 'X', 'TYT': 'Y', 'PYA': 'A', 'PYC': 'P', 'DBU': 'X', 'TYQ': 'Y', 'TYS': 'Y', 'KST': 'K', 'CZ2': 'C', 'OCY': 'C', '2OP': 'X', 'P2Y': 'P', 'STA': 'X', 'HMR': 'R', 'NLE': 'L', 'HMI': 'X', 'BMT': 'T', 'CS4': 'C', 'HMF': 'A', 'IT1': 'K', 'CS1': 'C', 'HMA': 'X', 'HMB': 'X', 'NLN': 'L', 'SHP': 'G', 'CSO': 'C', 'CSI': 'G', 'CSH': 'X', 'DLE': 'L', 'CSA': 'C', 'AFA': 'N', 'CSB': 'C', 'DLS': 'K', 'SHC': 'C', 'CSY': 'T', 'CSX': 'C', 'CSZ': 'C', 'CSU': 'C', 'B3E': 'E', 'CSW': 'C', 'CSP': 'C', 'CSR': 'C', 'CZZ': 'C', 'N10': 'S', 'MGG': 'R', 'BTR': 'W', 'MGN': 'Q', 'C1X': 'K', 'TBM': 'T', 'TBG': 'G', 'CFY': 'F', 'HV8': 'X', 'CML': 'C', 'ISO': 'X', '175': 'A', '2TY': 'Y', 'HV7': 'X', 'CRW': 'A', 'SET': 'S', 'C12': 'G', 'ASU': 'X', 'SEP': 'S', 'LNT': 'L', '1TQ': 'W', 'DGN': 'Q', 'DGL': 'E', 'PVA': 'X', 'ASB': 'D', 'ASA': 'D', 'SEC': 'A', 'SEB': 'S', 'ASK': 'D', 'GT9': 'C', 'ASI': 'D', 'SEL': 'S', 'ASM': 'X', 'ASL': 'D', 'CLH': 'K', 'FRF': 'F', '3DR': 'X', 'FRD': 'X', 'CLD': 'A', 'CLE': 'L', 'LA2': 'K', 'TLX': 'X', 'BBC': 'C', 'IML': 'I', 'CLB': 'A', 'OXX': 'D', 'PDI': 'X', '4BA': 'X', 'CLV': 'A', 'OME': 'X', 'VME': 'V', 'DTY': 'Y', 'CY4': 'C', 'OMT': 'M', '2MR': 'R', 'BPE': 'C', '2MT': 'P', 'AAB': 'X', 'AAR': 'R', 'MC1': 'S', 'CYR': 'C', 'CYQ': 'C', 'GYC': 'C', 'BIF': 'F', '2BU': 'X', 'BIC': 'X', 'GTH': 'X', 'POM': 'P', 'CYG': 'C', 'CYF': 'C', 'CYD': 'C', 'CYJ': 'K', '2BD': 'X', 'CY3': 'C', 'FKI': 'X', 'CY1': 'C', 'CLG': 'K', 'CY7': 'C', 'DHI': 'H', 'MLE': 'L', 'CWR': 'A', 'PO0': 'X', '32S': 'W', '32T': 'W', 'MLZ': 'K', 'SLE': 'X', 'MLY': 'K', 'NRI': 'X', 'MCL': 'K', 'AA4': 'A', 'AA6': 'X', 'BP4': 'X', 'NRQ': 'M', 'MCS': 'C', '2PP': 'X', 'PAT': 'W', 'KI2': 'X', 'PAA': 'X', 'DCL': 'X', 'DCI': 'X', 'TH5': 'T', '4HT': 'W', 'HSO': 'H', 'HSL': 'S', 'DCZ': 'X', 'DCY': 'C', 'GPL': 'K', 'THX': 'X', 'THO': 'X', 'BNO': 'X', 'BNN': 'A', 'HAQ': 'X', 'BNA': 'X', 'THC': 'T', 'IAS': 'D', 'PHI': 'F', 'PHM': 'F', 'PHL': 'F', 'PHA': 'F', 'PHD': 'D', 'SYS': 'C', 'BG1': 'S', 'NIY': 'Y', 'OAS': 'S', 'PHQ': 'X', 'NIT': 'X', 'CRQ': 'Q', 'APP': 'X', 'CRU': 'E', 'DMH': 'N', 'PRR': 'A', 'CRX': 'A', 'DMK': 'D', 'AEA': 'X', 'DMT': 'X', 'CRG': 'X', 'EMR': 'X', 'AEI': 'T', 'CRK': 'M', 'PS0': 'X', 'CRO': 'G', 'MFC': 'G', 'B3X': 'N', 'LDH': 'K', 'TCR': 'X', 'TCQ': 'Y', 'BUC': 'C', 'BUG': 'L', 'MHO': 'M', 'MHL': 'L', 'DDX': 'X', 'FOR': 'X', 'FOE': 'C', 'FOG': 'F', 'EFC': 'C', 'DDE': 'H', 'OHI': 'H', 'CR2': 'G', 'CR0': 'T', 'CR7': 'K', 'OPR': 'R', 'CR5': 'G', 'MOR': 'X', 'CR8': 'H', 'PSA': 'F', 'RNG': 'X', 'ANI': 'X', 'LCX': 'K', 'PSE': 'X', 'NVA': 'V', 'OPN': 'X', 'OPH': 'X', 'LCK': 'K', 'ILG': 'E', 'ZHP': 'X', '6CL': 'K', 'DVA': 'V', '5ZA': 'X', 'BCC': 'X', 'BLE': 'L', 'ETA': 'X', 'BCX': 'C', 'PED': 'X', 'PEA': 'X', 'ILX': 'I', 'BCS': 'C', 'DSE': 'S', 'OLT': 'T', 'LED': 'L', 'C6C': 'C', 'IEY': 'H', 'CH6': 'M', '6CW': 'W', 'PSH': 'H', 'B3K': 'K', 'S1H': 'S', 'FZN': 'K', 'B3S': 'S', 'YRR': 'X', 'OBS': 'K', 'DYG': 'D', 'CDE': 'X', 'PLP': 'X', 'PLE': 'L', 'NME': 'X', 'NMC': 'G', 'QNC': 'X', 'NMM': 'R', 'DIL': 'I', 'FHL': 'K', 'AR2': 'R', 'MOP': 'X', 'AR4': 'E', 'RCY': 'C', 'CY0': 'C', 'LOL': 'X', 'LOV': 'X', 'DIY': 'X', 'IYR': 'Y', '3PA': 'X', 'DIV': 'V', 'DIP': 'X', 'AIB': 'A', 'SOC': 'C', 'XXY': 'T', 'PPH': 'L', 'PPN': 'F', '2ML': 'L', 'MBZ': 'X', 'NSP': 'X', 'FAG': 'X', 'XX1': 'K', 'MTY': 'Y', 'YOF': 'Y', 'HPQ': 'F', 'M0H': 'C', 'C99': 'T', 'HPH': 'F', '4DP': 'W', 'HPE': 'F', 'HPD': 'X', 'SDP': 'S', 'RC7': 'H', 'LPL': 'X', 'ARM': 'R', 'ARO': 'R', 'DRZ': 'X', 'CCY': 'X', 'PR3': 'C', 'DRP': 'X', 'BOR': 'R', 'SVY': 'S', 'CCS': 'C', 'NAM': 'A', 'EPO': 'X', 'TIH': 'A', 'NAL': 'A', 'BOC': 'X', 'HRG': 'R', 'LYP': 'K', 'SXE': 'S', 'LYR': 'K', 'ML3': 'K', 'PIA': 'A', 'MYR': 'X', 'LYX': 'K', 'LYZ': 'K', 'PIP': 'X', 'LYM': 'K', 'LYN': 'K', 'PIV': 'X', 'OHS': 'D', 'SVA': 'S', 'TYO': 'Y', 'SVZ': 'S', 'SVX': 'S', 'XAO': 'X', 'SVV': 'S', 'CQR': 'G', 'IPG': 'G', '3TY': 'Y', 'BIU': 'I', 'TMD': 'T', 'CXM': 'M', 'SOY': 'S', 'IPN': 'X', 'FLT': 'Y', 'DHL': 'S', 'TYC': 'Y', 'FLE': 'L', 'VDL': 'V', 'PTM': 'Y', 'PTL': 'X', 'SCH': 'C', 'PTH': 'Y', 'LLP': 'K', 'AME': 'M', 'MNV': 'V', 'ETO': 'X', 'DBZ': 'A', 'MNL': 'L', 'C3Y': 'C', 'PEC': 'C', 'AMU': 'X', 'PTR': 'Y', 'SCS': 'C', 'MN8': 'X', 'TRJ': 'X', 'TRO': 'W', 'TRN': 'W', 'MN1': 'X', 'MN2': 'X', 'MN7': 'X', 'R1F': 'C', 'TRX': 'W', 'PBF': 'F', 'R1B': 'C', 'MLL': 'L', 'YCM': 'C', 'PBB': 'C', 'TRQ': 'W', 'SC2': 'C', 'IVA': 'X', 'VOL': 'X', 'HTI': 'C', 'MPT': 'X', 'M3L': 'K', 'MPR': 'X', 'HTR': 'W', 'MPQ': 'G', 'APE': 'X', 'ACB': 'D', 'ACA': 'X', 'ACE': 'X', 'SUN': 'S', 'SUI': 'D', 'ACL': 'R', 'HFA': 'X', 'ACY': 'X', 'NEP': 'H', 'CGN': 'X', 'NBQ': 'Y', 'ODS': 'X', 'TEE': 'C', 'HY3': 'P', '2DF': 'X', 'ODA': 'X', 'CGU': 'E', 'DNE': 'L', 'DNG': 'L', 'UMA': 'A', 'PM3': 'F', 'DNM': 'L', 'DNL': 'K', 'GMA': 'E', '1LU': 'L', 'ADD': 'X', 'CUC': 'X', 'GMU': 'X', 'MEG': 'E', 'MEA': 'F', 'LEF': 'L', 'S02': 'X', 'MEU': 'G', 'FBA': 'X', 'LET': 'K', 'FBE': 'X', 'X9Q': 'A', '3AH': 'H', 'MSU': 'X', '1PA': 'F', 'HQU': 'X', 'MSO': 'M', 'CIR': 'R', 'PF5': 'F', 'MSE': 'M', 'MSA': 'G', 'PXZ': 'X', 'DAB': 'A', 'OTY': 'Y', 'DAL': 'A', 'DAM': 'X', 'SGR': 'S', 'DAH': 'F', 'CLT': 'X', 'DAR': 'R', 'DAS': 'D', 'SGB': 'S', 'TRF': 'W', 'GVL': 'S', 'HOA': 'X', 'LLY': 'K', 'ESD': 'X', 'ESC': 'M', 'ESB': 'Y', 'DA2': 'R', 'TNB': 'C', 'PFF': 'F', 'LTA': 'X', 'KGC': 'K', 'HHK': 'A'}
#NB : Asp+Asn=Asx; Gln+Glu=Glx

standard_1letter = {"ALA":'A', "CYS":'C', "ASP":'D', "THR":'T', "VAL":'V', "TRP":'W', "TYR":'Y', "GLU":'E', "PHE":'F', "GLY":'G', "HIS":'H',\
                        "ILE":'I', "LYS":'K', "LEU":'L', "MET":'M', "ASN":'N', "PRO":'P', "GLN":'Q', "ARG":'R', "SER":'S'}

#Atomes du Backbone dans l'ordre des PDB
Backbone_Atoms = ['N','CA','C','O']
#Atomes des sides chaines dans l'ordre des PDB
SideChaine_Atoms = ['CB','CG','OG1','CG1','CG2','CD1','ND1','CD2','NE1','CE1','CE2','CE3','CD','SD','NE','CZ','NH1','NH2','CE','NZ','OD1','ND2','OD2',\
			'SG','OE1','OE2','OG','NE2','CZ2','CZ3','CH2','OD','OH','OXT']
			
#Equivalences entre les noms des atomes usites
DefAtomes = {'N':'N', \
	'CA':'CA',\
	'C':'C',\
	'O':'O','O1':'O',\
	'CB':'CB',\
	'CG':'CG',\
	'CD1':'CD1',\
	'CD2':'CD2','AD2':'CD2',\
	'CD':'CD',\
	'NE':'NE',\
	'CZ':'CZ',\
	'NH1':'NH1',\
	'NH2':'NH2',\
	'CE':'CE',\
	'NZ':'NZ',\
	'OD1':'OD1', 'AD1':'OD1',\
	'ND2':'ND2', 'AD2':'ND2',\
	'SD':'SD',\
	'OD2':'OD2',\
	'CE1':'CE1','AE1':'CE1',\
	'CE2':'CE2',\
	'SG':'SG',\
	'OG':'OG',\
	'OE1':'OE1','AE1':'OE1',\
	'OE2':'OE2',\
	'NE2':'NE2', 'AE2':'NE2',\
	'OG1':'OG1',\
	'CG2':'CG2',\
	'NE1':'NE1',\
	'CE3':'CE3',\
	'CZ2':'CZ2',\
	'CZ3':'CZ3',\
	'CH2':'CH2',\
	'ND1':'ND1', 'AD1':'ND1',\
	'OD':'OD',\
	'OH':'OH',\
	'CG1':'CG1',\
	'OXT':'OXT','O2':'OXT' #Terminal oxygen atoms are presented as OXT for proteins
	}

# Longueur ideal d'une liaison C-N au niveau du backbone
BondlengthCN = 1.33
BondlengthCaN = 1.47
BondlengthCaC = 1.53
#BondlengthCaCa = BondlengthCaC+BondlengthCaN+BondlengthCN 
BondlengthCaCa =3.8


# Sigles d'ion ou modif mis au debut des sequences prot comme si c'etaient des aa (non pris en compte)
SiglesDebSeqNPC = {"ACE":'Acetylation',"MLI":'Ion malonate', "NRQ":"Chromophore","PVL":"PYRUVOYL GROUP"}


#Atomes dans chaines des residus
AtomsPerResidusSC = {'GLY':[], 'ALA':['CB'], 'LEU':['CB','CG','CD1','CD2'],'ARG':['CB','CG','CD','NE','CZ','NH1','NH2'], 'LYS':['CB','CG','CD','CE','NZ'],\
			'ASN':['CB','CG','OD1','ND2'], 'MET':['CB','CG','SD','CE'], 'ASP':['CB','CG','OD1','OD2'], 'PHE':['CB','CG','CD1','CD2','CE1','CZ'],\
			'CYS':['CB','SG'], 'PRO':['CB','CG','CD'], 'GLU':['CB','CG','CD','OE1','OE2'], 'SER':['CB','OG'], 'GLN':['CB','CG','CD','OE1','NE2'],\
			'THR':['CB','OG1','CG2'], 'TRP':['CB','CG','CD1','CD2','NE1','CE2','CE3','CZ2','CZ3','CH2'], 'HIS':['CB','CG','ND1','CD2','CE1','NE2'],\
			'TYR':['CB','CG','CD1','CD2','CE1','CE2','CZ','OH'], 'VAL':['CB','CG1','CG2'], 'ILE':['CB','CG1','CG2','CD1']}

radius_vanderWaal = {'C':1.70,'N':1.55,'O':1.52,'S':1.80,'P':1.80}
pb_dict = {0:"a",1:"b",2:"c",3:"d",4:"e",5:"f",6:"g",7:"h",8:"i",9:"j",10:"k",11:"l",12:"m",13:"n",14:"o",15:"p",999:"z"}
