#!/usr/bin/env python
import sys
sys.path = ['/home/crimee/faure/Bureau/iPBAVizu/ipba_prog','/home/crimee/faure/Bureau/iPBAVizu','/usr/lib/python2.7','/usr/lib/python2.7/plat-linux2','/usr/lib/python2.7/lib-tk','/usr/lib/python2.7/lib-old','/usr/lib/python2.7/lib-dynload','/usr/local/lib/python2.7/dist-packages','/usr/lib/python2.7/dist-packages','/usr/lib/python2.7/dist-packages/PIL','/usr/lib/python2.7/dist-packages/gst-0.10','/usr/lib/python2.7/dist-packages/gtk-2.0','/usr/lib/python2.7/dist-packages/ubuntu-sso-client','/usr/lib/python2.7/dist-packages/ubuntuone-client','/usr/lib/python2.7/dist-packages/ubuntuone-control-panel','/usr/lib/python2.7/dist-packages/ubuntuone-couch','/usr/lib/python2.7/dist-packages/ubuntuone-installer','/usr/lib/python2.7/dist-packages/ubuntuone-storage-protocol']





from math import *
from os import path
from os import mkdir
from os import popen
from os import listdir
from os import system
from os import getcwd
from copy import *
import getopt
import StructBuilder
import cPickle
import random
import needle
import re
import numpy as np
import pb_alignment

__doc__="""Lancement principal du programme pour parser les fichiers PDBs
-F :			 File with the list of PDBs(multiple PDB input)
-r : 			 Directory with PDB files(multiple PDB input)
-i :			 Name of the PDB file (single input)	
-f :			 Start index for the PDB files to be read
-l :			 End index for the PDB files to be read
-b : 			 Name of the file where databank statistics will be saved
-n :			 Accessibility info from NACCESS required in the summary 	
-d :			 Secondary structure assignment by DSSP required in the summary
-s :			 Secondary structure assignment by STRIDE required in the summary
-x : 			 Secondary structure assignment by XTLSSTR required in the summary
-p :			 Secondary structure assignment by PROMOTIF required in the summary
-S :                     Secondary structure assignment by SEGNO required in the summary
-k :                     Secondary structure assignment by KAKSI required in the summary
-B :			 Break sequences will be saved as fasta format files	
-y :			 Accessibility and secondary structure assignments have to be stored. By default these files are deleted.
-o :			 Directory where the output files will be stored. It is advisable to use this option to prevent flooding of the working directory	
-z : 			 Assignment output will to be tar-zipped	 	
--log : 		 File to report error messages
--scop_list		 file having the list of scop families in pali
--palipw_dir		 dir with scop pairwiqe alignments
--palim_dir		 dir with pali multiple alignments
--type 			 alignment type: global or local
--matrix		 PB substitution matrix to be used	
"""
#-p :                     Path of the directory where PDB files for each Chain will be saved
#-s :                     Name of the file with PDB statistics
#-a :                     Path of the directory where NACCESS outputs will be saved(Note that -p option is compulsory for NACCESS)
#-l :                     Path of the directory where DSSP outputs will be saved(Note that -p option is compulsory for DSSP)
#-e :                     Path of the directory where chain summaries will be saved      
#-q :                     Path of the directory where chain sequences will be saved      
#-b :                     Path of the directory where the sequences of breaks will be saved              
 
Defaut_LOG = "ProblemsParsing.log"
#dict_data = test_dataset.dict_data
#-------------------------------------------------------------------------------------------------------------
# Erreur pour le lancement du prog
class Usage(Exception):
	def __init__(self, msg):
		self.msg = msg
class GenException (Exception):
        def __init__(self):
                print >>sys.stderr, "GDT_TS calculation failed!!"


#-------------------------------------------------------------------------------------------------------------
def profit(pdb1,pdb2,ali,input,pdb_out,ref,altype=None):
        pfit = open(input,'w')
        #pfit.write("hetatoms\n")
        pfit.write("reference %s\n"%(pdb1))
        pfit.write("mobile %s\n"%(pdb2))
        pfit.write("atoms ca\n")
        pfit.write("readalignment %s\n"%(ali))
        pfit.write("ignoremissing \n")
        #pfit.write("atoms ca\n")
	if altype != 'loc':
        	pfit.write("fit\n")
        	pfit.write("nfitted\n")
		pfit.write("write %s1\n"%(pdb_out))
        	pfit.write("iterate 5\n")
        pfit.write("fit\n")
        pfit.write("nfitted\n")
        pfit.write("write %s\n"%(pdb_out))
        pfit.write("printalign fasta %s\n"%(ref))
        pfit.write("quit\n")
        pfit.close()

def parse_profit(pair, out_file, ref):
	dict = {}
	try:
		o = open(out_file, 'r')
		lines = o.readlines()
		o.close()
	except IOError, msg: print msg
	i = 0
	list = []
	for l in lines:
		if re.search("RMS:", l) != None: 
			list.append(float(l[:-1].split('RMS:')[-1]))
		if re.search("Number of fitted atoms:", l) != None:
			list.append(float(l[:-1].split('Number of fitted atoms:')[-1]))
			if len(list) != 0:
				try: dict[pair].append(list)
				except KeyError: dict[pair] = [list]
			list = []
		i += 1
	
	try:
                pa = open(ref, 'r')
                lines = pa.readlines()
                pa.close()
        except IOError, msg: print msg
	flag_enter = 0
	res_aln1 = []
	res_aln2 = []
	for lin in lines:
		flag_skip = 0
		for i in range(len(lin)):
                        if lin[i] == '>':
                                flag_enter += 1
				flag_skip = 1
				break
		if flag_skip == 1: continue
		if flag_enter == 1:
			for i in range(len(lin[:-1])):
                        	if lin[:-1][i] != ' ': res_aln1.append(lin[:-1][i])
		if flag_enter == 2:
                        for i in range(len(lin[:-1])):
                                if lin[:-1][i] != ' ': res_aln2.append(lin[:-1][i])


	return dict, res_aln1, res_aln2


def gdt(pdb1,pdb2,seq1,seq2):
        coord1 = {}
        coord2 = {}
        neq = {}
        percent_neq = {}
        sf_neq = {}
        avg_sf = {}
        lga_sf = {}
        sum_percent = 0
        count_percent = 0
        list_cutoff = [0.5,1.0,1.5,2.0,2.5,3.0,3.5,4.0,4.5,5.0,5.5,6.0,6.5,7.0,7.5,8.0]
        LGA = {}
        try:
                dict_lcs = {}
                dict_gdt = {}
                file1_pdb = pdb1
                if not path.isfile(file1_pdb):
                        print "Error in parsing fitted PDBs\n"
                        raise GenException
                file2_pdb = pdb2
                if not path.isfile(file2_pdb):
                        print "Error in parsing fitted PDBs\n"
                        raise GenException
                f1 = open(file1_pdb,'r')
                lines1 = f1.readlines()
                f1.close()
                ct1 = 0
                res1 = -100
                for l1 in lines1[:-1]:
                        el = l1.split()
                        el1 = [l1[30:37],l1[38:45],l1[46:53]]
                        if el[0] == 'ATOM' and el[2] == 'CA':
                                res2 = int(l1[22:26])
                                if res1 != res2:
                                        res1 = res2
                                        ct1 += 1
                                coord1[ct1] = [float(el1[0]),float(el1[1]),float(el1[2])]
                f2 = open(file2_pdb,'r')
                lines2 = f2.readlines()
                f2.close()
                ct2 = 0
                res1 = -100
                for l1 in lines2[:-1]:
                        el = l1.split()
                        el1 = [l1[30:37],l1[38:45],l1[46:53]]
                        if el[0] == 'ATOM' and el[2] == 'CA':
                                res2 = int(l1[22:26])
                                if res1 != res2:
                                        res1 = res2
                                        ct2 += 1
                                coord2[ct2] = [float(el1[0]),float(el1[1]),float(el1[2])]
                if ct1 < ct2: min_len = ct1
                else: min_len = ct2
#               al = open(aln_file,'r')
#               lines_al = al.readlines()
#               al.close()
		min_len = len(seq1)
		print ct1, ct2, min_len
                if len(seq1) < 3:
                        print "Error in parsing fitted PDBs\n"
                        raise GenException
#               seq1 = lines_al[2][:-2]
#               seq2 = lines_al[5][:-2]
                if len(seq1) != len(seq2):
                        print "Error in parsing fitted PDBs\n"
                        raise GenException
                count1 = 0
                count2 = 0
                list_respairs = []
                for i in range(len(seq1)):
                        if seq1[i] != '-':
                                count1 += 1
                                if seq2[i] != '-':
                                        count2 += 1
                                        list_respairs.append([count1,count2]) # first pdb (file2_pdb) is the reference
                        elif seq2[i] != '-':
                                count2 += 1
                if len(list_respairs) == 0:
                        raise GenException
                if not ct1 == count1 and not ct2 == count2:
                        print "Error in parsing fitted PDBs\n"
                        raise GenException
                fr = 0
                #print dict_lcs
                for cutoff in list_cutoff:
                        neq[cutoff] = 0
                        for rp in list_respairs:
                                dist = 0.0
                                flag_calc = 0
                                for i in range(3):
                                        try:
                                                dist += pow((coord1[rp[0]][i] - coord2[rp[1]][i]),2)
                                        except IndexError:
                                                flag_calc = 1
                                                break
                                if flag_calc == 1:
					raise GenException
                                distance = sqrt(dist)
                                if distance < cutoff:
                                        neq[cutoff] = neq[cutoff]+1
                        #print "neq for cutoff %f is %d"%(cutoff,neq[cutoff])
                        dict_gdt[cutoff] = (float(neq[cutoff])*100)/float(min_len)
                #print dict_gdt
                        #percent_neq[pair] = float(neq[pair])/float(len(list_respairs))
                #if percent_neq[pair] < 0.01: continue
                k = len(list_cutoff)
                sum_gdt = 0
                for i in range(1,k+1):
                        sum_gdt += (k-i+1)*dict_gdt[list_cutoff[i-1]]
                S_gdt = sum_gdt*(float(2)/float(k*(k+1)))
                if S_gdt == None: return -1
                else: return S_gdt
	except IndexError: return -1
		
		

		
				
#-------------------------------------------------------------------------------------------------------------
#Fonction Principale
def main(argv=None):
	dict_scop = {}	
	"""Fonction principale de lancement du parser PDB. Pour le moment, pas d'option. Donc manque la fonction de process des arguments"""
	
	#print "	Input file has to strictly follow PDB file format\n\
	#	Include the path of the Parser in the environment variable PYTHONPATH\n\
	#	All the data files and modules provided with the Parser are required (refer README)\n\
	#	Working versions of programs (like NACCESS, DSSP etc, refer README for the list) are required\n\
	#	Also, set aliases for these programs as per the instructions in README\n\
	#	Please check for the presence of files (in the output directory) having names same as those generated by the Parser, \n\
	#	these files will not be generated (or overwritten) if already present\n\
	#	Refer the output file formats of the different assignment programs (sec str, accessibility etc), in the examples directory,\n\
	#	check if the format is similar to those in the outputs generated by the version of these programs in your system"	
	##########################################################################################################
	# Gestion du lancement du programme
	##########################################################################################################
	# Cette partie rend le main plus flexible : le programme peut etre appelee du prompt de python
	if argv is None:
		argv = sys.argv
    	# parse command line options
	try:
		try:
			opts, args = getopt.getopt(argv[1:], "hF:f:l:r:b:i:ndsxpkSyzBo:", ["help","ListePDB=","NumPDBdeb=","NumPDBfin=","log=","scop_list=","palipw_dir=","palim_dir","type=","matrix=","p1=","p2=","c1=","c2="])
			#print opts, args
		        #the order of short and long flags needs to be the same, so you'll need
			#to specify all the short flags that do have corresponding long flags first, then all the
			#rest of the short flags.
			#opts, args = getopt.getopt(argv[1:], "hea:", ["help","p="])
			#ex. : python EcrireUnMain.py -e -a bi  --p=bu file
			#[('-e', ''), ('-a', 'bi'), ('--p', 'bu')] ['file']
			
		except getopt.error, msg:
				raise Usage(msg)
	except Usage, err:
		print >>sys.stderr, err.msg
		print >>sys.stderr, "for help use --help"
		return 2
    	# process options
	#for o, a in opts:
		#print o
		#if o in ("-h", "--help"):
		#	print __doc__
		#	return 0 
	DicoOpt = dict(opts)
	if DicoOpt.has_key("-h") or DicoOpt.has_key("--help"):
		print __doc__
		return 0
    	# process arguments
#	for arg in args:
#		pass
		#print args


	####################################################################################################
	# Deroulement du programme
	####################################################################################################
	#print DicoOpt

	#Chargement de la liste des PDBs a lire
#	if not DicoOpt.has_key("-F"):	
#		print >>sys.stderr, "Un fichier contenant la liste des PDBs a lire doit etre precise\nfor help use --help"
#		return 2
#	if not DicoOpt.has_key("-r"):	
#		print >>sys.stderr, "Le repertoire contenant les PDBs a lire doit etre precise\nfor help use --help"
#		return 2
#	if DicoOpt.has_key("-F") and DicoOpt.has_key("-r"): 
#		FichierListePDB = open(DicoOpt["-F"],'r')
#		LigneListePDB = FichierListePDB.readlines()
#		FichierListePDB.close()
#		ListePDB = [ligne[:-1] for ligne in LigneListePDB]
#		list_random = random.sample(ListePDB, 50)
	#print ListePDB 
#	elif (DicoOpt.has_key("-F") and not DicoOpt.has_key("-r")) or (not DicoOpt.has_key("-F") and DicoOpt.has_key("-r")):
#		print "please give both the list of pdbs and the directory information for the input"

#	if DicoOpt.has_key("-i"):
#		pdb_file = DicoOpt["-i"]
#		if DicoOpt.has_key("-F") or DicoOpt.has_key("-r"):
#			print "error: please give either a single pdb or a list of pdbs as input, both options used !!!"
#			raise Exception
#	else: pdb_file = None

	if DicoOpt.has_key("--p1"): pdb1 = DicoOpt["--p1"]
	else: 
		pdb1 = None
		print "error: pdb file name missing"
		raise Exception
	if DicoOpt.has_key("--p2"): pdb2 = DicoOpt["--p2"]
	else:  
                pdb2 = None 
                print "error: pdb file name missing" 
                raise Exception 

	if DicoOpt.has_key("--c1"): ch1 = DicoOpt["--c1"]
	else: ch1 = None
	if DicoOpt.has_key("--c2"): ch2 = DicoOpt["--c2"]
	else: ch2 = None

	if DicoOpt.has_key("--type"):
		type = DicoOpt["--type"]
	else: type = 'global'
	if type != 'loc': type = 'global'
	
	#------------------------------------------------------------
	#Boucle sur les Fichiers PDB a traiter
	#------------------------------------------------------------
	# --> Indice de lecture du fichier des pdb a lire	
	if DicoOpt.has_key("-f"):
		IndiceDebutTraitement = int(DicoOpt["-f"])
	else:
		IndiceDebutTraitement = 0
	if DicoOpt.has_key("-l"):
		IndiceFinTraitement = int(DicoOpt["-l"])
	else:
		IndiceFinTraitement = None

#	if DicoOpt.has_key("-p"):
#		if not path.exists(DicoOpt["-p"]):
#			mkdir(DicoOpt["-p"])
#		pdb_dir = DicoOpt["-p"]
#	else:
#		pdb_dir = None	

	if DicoOpt.has_key("-n"):
		naccess = 1
	else:
		naccess = 0
	if DicoOpt.has_key("-d"):
		dssp = 1
	else:
		dssp = 0

	if DicoOpt.has_key("-y"):
		store_out = 1
	else: store_out = 0
	
	if DicoOpt.has_key("-o"):
		out_dir = DicoOpt["-o"]
	else: out_dir = None

	if DicoOpt.has_key("-z"):
		zip = 1
	else: zip = 0
		
	#--> Actions demandees lors du parsing
	#creation des repertoires et fichiers globaux necessaires
	
	#Fichier .log
	if DicoOpt.has_key("--log"):
		flog = DicoOpt["--log"]
	else:
		flog = Defaut_LOG	
	LOG = open(flog,'w')
	try:
		chain = {}
		dict_mat = {}
		dict_RMS = {}
		list_acc = []
                gap_seq = [] 
                list_dom_read = [] 
                dict_mat = {} 
                dict_RMS = {} 
                list_lengths = [] 
		dict_aa = {}
		dict_pos = {}
		dict_pb = {}
		dict_acc = {}
		dict_x ={}
		dict_y = {}
		dict_z = {}
                test = 0 
		if ch1 != None:
			chain[pdb1.lower().split('.')[0]] = ch1
		else: chain[pdb1.lower().split('.')[0]] = None
		if ch2 != None: 
                        chain[pdb2.lower().split('.')[0]] = ch2 
		else: chain[pdb2.lower().split('.')[0]] = None
		pairs = [pdb1,pdb2]
		list_keys = []
                for pdb in pairs: 
                        test += 1 
                        AA_seq = [] 
                        PB_seq = [] 
                        pos_seq = [] 
                        acc_seq = [] 
                        flag_read = 0
			dict_scop = {}
			if chain[pdb.lower().split('.')[0]] != None: elem = pdb.lower().split('.')[0]+chain[pdb.lower().split('.')[0]]
			else: elem = pdb.lower().split('.')[0]
			
			elem1 = pdb.lower().split('.')[0] 
                        try:  
                        	S1 = StructBuilder.StructBuilder(DicoOpt["-r"]+"/"+pdb) 
                        	flag_read = 1 

                       	except Exception,msg: 
                                print msg
				LOG.write("%s\n"%(msg))
				LOG.write("PDB file could not be opened!!, %s\n"%(pdb))
				sys.exit(1) 
                        if flag_read == 1: 
                        	try:  
                	        	dict_scop = deepcopy(S1.Build_Chains(None, naccess, dssp, None, None, None, None, None, store_out, out_dir, zip, None, False, chain[elem1],elem)) 
                                except Exception, msg: 
                                        print  msg
					LOG.write("Error in parsing PDB file!!, %s\n"%(pdb)) 
					sys.exit(1)
                                        continue 
				chain_key1 = dict_scop.keys()[0]
				chain_key = elem
				#print chain_key,elem
				list_keys.append(chain_key)
                                for i in range(len(dict_scop[chain_key1])):  
                                	try: dict_aa[chain_key].append(dict_scop[chain_key1][i][0]) 
                                        except KeyError: dict_aa[chain_key] = [dict_scop[chain_key1][i][0]] 
                                for i in range(len(dict_scop[chain_key1])):  
                                        try: dict_pb[chain_key].append((dict_scop[chain_key1][i][1])) 
                                        except KeyError: dict_pb[chain_key] = [dict_scop[chain_key1][i][1]] 
                                for i in range(len(dict_scop[chain_key1])):  
                                        try: dict_pos[chain_key].append(dict_scop[chain_key1][i][3]) 
                                        except KeyError: dict_pos[chain_key] = [dict_scop[chain_key1][i][3]] 
                                for i in range(len(dict_scop[chain_key1])):  
                                        try: dict_acc[chain_key].append(dict_scop[chain_key1][i][4]) 
                                        except KeyError: dict_acc[chain_key] = [dict_scop[chain_key1][i][4]] 
                                for i in range(len(dict_scop[chain_key1])):
                                        try: dict_x[chain_key].append(dict_scop[chain_key1][i][5])
                                        except KeyError: dict_x[chain_key] = [dict_scop[chain_key1][i][5]]
                                for i in range(len(dict_scop[chain_key1])):
                                        try: dict_y[chain_key].append(dict_scop[chain_key1][i][6])
                                        except KeyError: dict_y[chain_key] = [dict_scop[chain_key1][i][6]]
                                for i in range(len(dict_scop[chain_key1])):
                                        try: dict_z[chain_key].append(dict_scop[chain_key1][i][7])
                                        except KeyError: dict_z[chain_key] = [dict_scop[chain_key1][i][7]]
		if type == 'loc':
			loc_init = [700] 
                	loc_ext = [1000]
		else:
                	loc_init = [800]
                	loc_ext = [1000]
                glob_init = [500]
                glob_ext = [400]
		list_keys.reverse()
                for li in loc_init:
                        #matrices = "sim_aa2_exp_"+`li`+"_le_"+`loc_ext[0]`+"_gi_"+`glob_init[0]`+"_ge_"+`glob_ext[0]`
			matrices = "alignment_details"
			dict_scores = {}
			dictRMSD = {}
			list_tmp = []
			ct = 0
			flag_number = 0
                        for k in list_keys:
                                list_tmp.append(k)
                                for l in list_keys:
                                        if l not in list_tmp:
                                                ct += 1
                                                #print k+l
                                                #if len(dict_pb[k]) >= 1000 or len(dict_pb[l]) >= 1000:
                                                #        print "length greater than 1000 for one of %s"%(k+l)
                                                #        continue
                                                try:
                                                        pb1,pb2 = dict_pb[k][:],dict_pb[l][:]
                                                        pos1,pos2 = dict_pos[k][:],dict_pos[l][:]
                                                        acc1,acc2 = dict_acc[k][:],dict_acc[l][:]
                                                        aa1,aa2 = dict_aa[k][:],dict_aa[l][:]
                                                        x1,x2 = dict_x[k][:],dict_x[l][:]
                                                        y1,y2 = dict_y[k][:],dict_y[l][:]
                                                        z1,z2 = dict_z[k][:],dict_z[l][:]
                                                except KeyError:
							LOG.write("Alignment Error!!, %s\n"%(k+l))
							sys.exit(1) 
							continue
						k = k.upper()
                                                l = l.upper()
                                                al = type
                                                if not path.isdir(out_dir+"/"+matrices): mkdir(out_dir+"/"+matrices)
                                                #if not path.isdir(out_dir+"/"+matrices+"/"+k+l): mkdir(out_dir+"/"+matrices+"/"+k+l)
                                                file_write = out_dir+"/"+matrices+"/"+k+l+"/"+k+l+".pb"
                                                file_path = getcwd()+"/"+out_dir+"/"+matrices+"/"+k+l #R
                                                file_aa = out_dir+"/"+matrices+"/"+k+l+"/"+k+l+".aa"
                                                file_temp =  out_dir+"/"+matrices+"/"+"temp_pbaln.pb"
                                                if path.isfile(file_temp): system("rm %s"%(file_temp))

                                                flag_profit = 2
                                                if flag_profit != 2:
                                                        continue #R to enter the rmsd calculation alone
                                                        try:
                                                                res1, res2, raw1, raw2 = pb_alignment.align_PB(pb1,pb2,pos1,pos2,aa1,aa2,al,file_temp,"temp",matrices, matrices, acc1, acc2,False)
                                                                dict_scores[k+l] = [float(raw1),float(raw2)]
                                                        except Exception, msg:
                                                                print msg
                                                                print "error: could not align %s, %s"%(k+l, matrices)
                                                                continue
                                                        continue
                                                else:
                                                        if not path.isdir(out_dir+"/"+matrices+"/"+k+l): mkdir(out_dir+"/"+matrices+"/"+k+l)
                                                        try:
                                                                res1, res2, scorelist, pb1_aln, pb2_aln, AncBound = pb_alignment.align_PB(pb1,pb2,pos1,pos2,aa1,aa2,x1,x2,y1,y2,z1,z2,al,file_path,"temp",matrices, matrices, li, loc_ext[0], glob_init[0], glob_ext[0], acc1, acc2,True)
                                                        except IOError, msg:
                                                                print msg
                                                                print "error: could not align %s, %s"%(k+l, matrices)
								LOG.write("Alignment Error!!, %s"%(k+l))
								sys.exit(1)
                                                                continue
                                                if res1 == None or res2 == None: print "Error in PB alingment!!!!\n"
						flag_profit_success = 0
						print "rmsd calculation: %s\n"%(k+l)
						try: 
							dictRMSD[k+l] = []
        	                                	aa_al = open(file_aa, 'w')
                	                                aa_al.write(">P1;"+k+".pdb\n")
							aa_al.write("Reference Sequence - "+k+".pdb"+"\n")
                                	                aa_al.write(''.join(res1))
							aa_al.write("*\n")
	                                                aa_al.write(">P1;"+l+".pdb"+"\n")
							aa_al.write("Mobile Sequence -"+l+".pdb"+"\n")
                	                                aa_al.write(''.join(res2))
							aa_al.write("*\n")
                                	                aa_al.close()
							prof_out_dir = out_dir+"/"+matrices+"/"+(k+l).upper()
							profit_in = prof_out_dir+"/"+(k+l)+".in"
							profit_out = prof_out_dir+"/"+(k+l)+".out"
							pdb_inp = out_dir+"/"+k.lower()+".pdb"
							pdb_out = prof_out_dir+"/"+(k+l)+"_fit.pdb"
							out_aln = prof_out_dir+"/"+(k+l)+".fas"
							profit(out_dir+"/"+k.lower()+".pdb",out_dir+"/"+l.lower()+".pdb",file_aa,profit_in,pdb_out,out_aln,type)
							command = sys.path[0]+"/ProFitV3.1/src/profit -h < %s | cat > %s"%(profit_in, profit_out)
						except IndexError:
							print "Alignment Error!!!"
							LOG.write("Alignment Error!!, %s"%(k+l))
							#sys.exit(1)
							flag_profit_success = 1 
							continue
						try: 
							system(command)
							dict_rmsd, res_1, res_2 = parse_profit(k+l,profit_out,out_aln)
						except Exception, msg:
							print msg
							print "Error in refining the alignment using Profit %s\n"%(k+l)
							LOG.write("Error in refining the alignment using Profit %s\n"%(k+l))
							flag_profit_success = 1
							continue
						try:
							if len(dict_rmsd[k+l]) == 0:
								LOG.write("Error in refining the alignment using Profit %s\n"%(k+l))
								#print "profit error"
								flag_profit_success = 1
								continue
						except KeyError:
							LOG.write("Error in refining the alignment using Profit %s\n"%(k+l)) 
							print "ProFit fitting error!!\n"
							flag_profit_success = 1
		#key = dict_rmsd.keys()
		#print dict_rmsd
		if type == 'loc' and AncBound.has_key(0):
			lo1 = int(AncBound[0][0]) - 1
			lo2 =  int(AncBound[0][1]) - 1
		out_aln = out_dir+"/output_alignment"
		prof = open(out_aln, 'w')
		prof.write(">1: PB alignment\n")
		if type == 'loc' and AncBound.has_key(0):
			prof.write("%s\n"%(''.join(pb2_aln[lo1:lo2]).lower()))
			prof.write("%s\n"%(''.join(pb1_aln[lo1:lo2]).lower()))
		else:
			prof.write("%s\n"%(''.join(pb2_aln).lower()))
			prof.write("%s\n"%(''.join(pb1_aln).lower()))
		prof.write(">2: AA1 alignment\n")
		if type == 'loc' and AncBound.has_key(0):
			prof.write("%s\n"%(''.join(res2[lo1:lo2])))
			prof.write("%s\n"%(''.join(res1[lo1:lo2])))
		else:
			prof.write("%s\n"%(''.join(res2)))
			prof.write("%s\n"%(''.join(res1)))
		position1 = ''
		position2 = ''
		i = 0
		if len(pos1) == len(res1) - res1.count('-'):
			for j in range(len(res1)):
				if res1[j] != '-': 
					i += 1
					if (i%10) == 1:
						position1 += "%-10s"%(pos1[i-1].strip())
				else: position1 += ' '
			if len(pos2) == len(res2) - res2.count('-'):
				i = 0
                                for j in range(len(res2)):
                                	if res2[j] != '-': 
						i += 1
                                        	if (i%10) == 1:
                                                	position2 += "%-10s"%(pos2[i-1].strip())
					else: position2 += ' '
				if type == 'loc' and AncBound.has_key(0):
					for rq in range(lo1,lo1+5):
						if position1[lo1] != ' ':
							if position1[rq] != ' ': position1 = position1[:rq]+' '+position1[rq+1:]
						if position2[lo1] != ' ':
							if position2[rq] != ' ': position2 = position2[:rq]+' '+position2[rq+1:]
						if position1[lo2] != ' ':
							if position1[lo2-(rq-lo1)] != ' ': position1 = position1[:lo2-(rq-lo1)]+ ' '+position1[(lo2-(rq-lo1))+1:]
						if position2[lo2] != ' ':
                                                	if position2[lo2-(rq-lo1)] != ' ': position2 = position2[:lo2-(rq-lo1)]+ ' '+position2[(lo2-(rq-lo1))+1:]
					
					prof.write("%s\n"%(position2[lo1:lo2]))	
					prof.write("%s\n"%(position1[lo1:lo2]))
				else:
					prof.write("%s\n"%(position2))
					prof.write("%s\n"%(position1))
		if len(AncBound) != 0:
			prof.write(">5: Anchor Positions (Seq1)\n")
			if  type != 'loc':
				for i in range(len(AncBound)):
					if i == (len(AncBound) - 1): prof.write("%d %d\n"%(AncBound[i][0]+(int(pos2[0][:-1])-1),AncBound[i][1]+(int(pos2[0][:-1])-1)))
					else: prof.write("%d %d:"%(AncBound[i][0]+(int(pos2[0][:-1])-1),AncBound[i][1]+(int(pos2[0][:-1])-1)))
		#command = "python2.5 %s/calculate_GDTTS.py -p1 %s -p2 %s -r1 %s -r2 %s"%(sys.path[0],pdb_inp,pdb_out,''.join(res1),''.join(res2))
		flag_gdt = 0
		try:
			gdt_score = gdt(pdb_inp,pdb_out,''.join(res_1),''.join(res_2))
		except IOError, msg:
			print msg
			flag_gdt = 1
		if gdt_score == -1 or gdt_score == 0:
                	flag_gdt = 1
		if flag_profit_success == 0:
			key = dict_rmsd.keys()
			prof.write(">3: AA2 alignment - ProFit\n")
			if type == 'loc' and AncBound.has_key(0):
				prof.write("%s\n"%(''.join(res_2[lo1:lo2])))
				prof.write("%s\n"%(''.join(res_1[lo1:lo2])))
				
				seq_aa_1 = ''.join(res_1[lo1:lo2])
				seq_aa_2 = ''.join(res_2[lo1:lo2])
				seq_pb_1 = ''.join(pb1_aln[lo1:lo2]).lower()
				seq_pb_2 = ''.join(pb2_aln[lo1:lo2]).lower()
			else:
				prof.write("%s\n"%(''.join(res_2)))
	        	prof.write("%s\n"%(''.join(res_1)))
	        	lo2 = len(res_1)
	        	lo1 = 0
	        	seq_aa_1 =  ''.join(res_1)
	        	seq_aa_2 =  ''.join(res_2)
	        	seq_pb_1 = ''.join(pb1_aln).lower()
	        	seq_pb_2 = ''.join(pb2_aln).lower()

			position1 = ''
			position2 = ''
			if len(pos1) == len(res_1) - res_1.count('-'):
	                        i = 0
                                for j in range(len(res_1)):
                                        if res_1[j] != '-': 
						i += 1
        	                        	if (i%10) == 1:
                	                        	position1 += "%-10s"%(pos1[i-1].strip())
					else: position1 += ' '
	                        if len(pos2) == len(res_2) - res_2.count('-'):
        	                        i = 0
                                	for j in range(len(res_2)):
                                        	if res_2[j] != '-': 
							i += 1
                	                        	if (i%10) == 1:
                        	                        	position2 += "%-10s"%(pos2[i-1].strip())
						else: position2 += ' '
                                	if type == 'loc' and AncBound.has_key(0):
                                        	for rq in range(lo1,lo1+5):
                                                	if position1[lo1] != ' ':
	                                                        if position1[rq] != ' ': position1 = position1[:rq]+' '+position1[rq+1:]
        	                                        if position2[lo1] != ' ':
                	                                        if position2[rq] != ' ': position2 = position2[:rq]+' '+position2[rq+1:]
                        	                        if position1[lo2] != ' ':
                                	                        if position1[lo2-(rq-lo1)] != ' ': position1 = position1[:lo2-(rq-lo1)]+ ' '+position1[(lo2-(rq-lo1))+1:]
                                        	        if position2[lo2] != ' ':
                                                	        if position2[lo2-(rq-lo1)] != ' ': position2 = position2[:lo2-(rq-lo1)]+ ' '+position2[(lo2-(rq-lo1))+1:]
						prof.write("%s\n"%(position2[lo1:lo2]))
                                        	prof.write("%s\n"%(position1[lo1:lo2]))
					else:
						prof.write("%s\n"%(position2))
                                		prof.write("%s\n"%(position1))
# Ajout pour l'alignement PB en sortie de profit
			seq_pb_1 =  seq_pb_1.replace("-","")
			seq_pb_2 =  seq_pb_2.replace("-","")

			seq_pb_1_align = ""
			seq_pb_2_align = ""
			
			j = 0
			k = 0
			for i in xrange(len(seq_aa_1)):
				if seq_aa_1[i] == "-":
					seq_pb_1_align += "-"
				else:
					seq_pb_1_align += seq_pb_1[j]
					j += 1
				if seq_aa_2[i] == "-":
					seq_pb_2_align += "-"
				else:
					seq_pb_2_align += seq_pb_2[k]
					k += 1
			
			prof.write(">6: PB alignment - ProFit\n")
			prof.write("%s\n" % seq_pb_2_align)
			prof.write("%s\n" % seq_pb_1_align)
########
			if len(dict_rmsd[key[0]]) == 2:
				prof.write(">4: Scores: Alnscore %7.2f: GDT_PB1 %5.2f: GDT_PB2 %5.2f: RMSD %5.2f: Nal %d: Aln_Len %d"%(float(scorelist[1]),float(scorelist[2]),float(scorelist[3]),dict_rmsd[key[0]][1][0],dict_rmsd[key[0]][1][1],lo2-lo1))
			elif len(dict_rmsd[key[0]]) == 1:
                                prof.write(">4: Scores: Alnscore %7.2f: GDT_PB1 %5.2f: GDT_PB2 %5.2f: RMSD %5.2f: Nal %d: Aln_Len %d"%(float(scorelist[1]),float(scorelist[2]),float(scorelist[3]),dict_rmsd[key[0]][0][0],dict_rmsd[key[0]][0][1],lo2-lo1))
			if flag_gdt == 0:
				prof.write(": GDT_TS %5.2f\n"%(float(gdt_score)))
			else: prof.write("\n")
		elif flag_profit_success == 1:
			#prof.write(">3: AA2 alignment - ProFit\n")
                        #prof.write("%s\n"%(''.join(res_1)))
                        #prof.write("%s\n"%(''.join(res_2)))
                        prof.write(">4: Scores: Alnscore %7.2f: GDT_PB1 %5.2f: GDT_PB2 %5.2f\n"%(float(scorelist[1]),float(scorelist[2]),float(scorelist[3])))
		prof.write("Alnscore : PB alignment score normalized by alignment length\n")
                prof.write("GDT_PB1 : Score similar to GDT_TS, indicates the precentage of favorable PB substitutions\n")
                prof.write("GDT_PB2 : Similar to GDT_PB1, but the percentage calculated on sum of aligned positions and number of gapped segments\n")
                prof.close()
		LOG.close()
	except IndexError,msg:
		print "Error aligning the PDBs!!"
		LOG.write("Alignment Error!!, %s\n"%(k+l))
		print msg
		sys.exit(1)

#-------------------------------------------------------------------------------------------------------------

#-------------------------------------------------------------------------------------------------------------
#Lancement du programme
if __name__ == "__main__":
	sys.exit(main())   
	#de meme, un sys.exit a l interieur de la fonction main fermerait le prompt python brutalement
