import PDB_Lecteur
import Definitions
import re
import sys

__doc__="""Module pour parser un fichier PDB lu"""

class NonEquivalenceChainesSEQRESetATOM (Exception):
	def __init__(self):
		print >>sys.stderr, "Les Id des chaines repertories dans SEQRES et ATOM ne sont pas compatibles"

#-------------------------------------------------------------------------------------------------------------
class PDBParser :
	
	
	

	def __init__(self, NomFichierPDB):
		"""Initiation d'un parseur de PDB.Par la creation simultanee d'un lecteur de PDB
		pour recuperer les dictionnaires des lignes PDB concernant le champ SEQRES et le champ ATOM et associe"""
		#Enregistrement du nom du PDB
		self.NomFichierPDB = NomFichierPDB
		#Creation d'un lecteur PDB
		LecteurPDB = PDB_Lecteur.PDB_Lecteur(NomFichierPDB)
		#utilisation du lecteur de PDB et la recuperation des lignes d'interets sous forme de dictionnaires ranges par chaines
#		try :
		LignesPDB = LecteurPDB.getSeqAndStruct()
#		except PDB_Lecteur.NombreDeChainesDifferent: #Si le nombre de chaine entre SEQRES et ATOM est different, l'exception est attrapee et on stop le prog
#			sys.exit()
		# Recup des dictionnaires des lignes PDB concernant le champ SEQRES et le champ ATOM et associe
		self._DictSEQRES  = LignesPDB[0] 
		self._DictATOM = LignesPDB[1] #Liste de dictionnaires : un dictionnaire pas MODEL
		self.ligne_resolution = LignesPDB[2]
		self.ligne_ExperimentType = LignesPDB[3]
		self.lines_rfactor = LignesPDB[6]
		#Initialisation des listes de sequences prot repertoriees dans SEQRES et ATOM
		self._ChainesProtSEQRES = []
		self._ChaineAProscrire =  []	
		self._ChainesProtATOM = []
		self.lines_modres = LignesPDB[4]
		self.lines_miss = LignesPDB[5]
		self.Dict_seqres = {}
		self.flag_seqres = 0

	def Verif_EquiChaine_SEQRESetATOM (self):
		#Si les chaines repertoriees dans SEQRES et ATOM ne sont pas les memes, on lance une exception
		#print self._ChainesProtSEQRES, self._ChainesProtATOM
		if self._ChainesProtSEQRES != self._ChainesProtATOM:
			#raise NonEquivalenceChainesSEQRESetATOM() #NB: se sont juste les id qui ne correspondent pas car on a deja verifier qu'il y en avait le meme nombre
			print "number of chains differ btw seqres and atom records"
        def Modresparser(self):
		Dict_modres = {}
		enz_mod = 0
		ptm = 0
		modres = {} 
		normal = 0
		count_nonaa = 0
		if len(self.lines_modres) != 0:
                	IterateurChaines = iter(self.lines_modres)
			while 1:
				try:
	                		chain = IterateurChaines.next()
        	        		lines_chain = self.lines_modres[chain]
                			for ligne in lines_chain:
                        			modres[ligne[19:23]] = ligne[12:15]
						if (ligne[29:60] == 'POST-TRANSLATIONAL MODIFICATION'):
							ptm += 1
						if ligne[12:15] == ligne[24:27]:
							normal += 1
						if ligne[24:27] == "   ":
							count_nonaa += 1
						try:
        	                			Dict_modres[chain].append(modres)
						except KeyError:
							Dict_modres[chain] = [modres]
				except StopIteration:
					break
			return Dict_modres, normal, count_nonaa, ptm
		else:
			Dict_modres = None
			return Dict_modres, normal, count_nonaa, ptm

        def Missingparser(self):
                dict_miss = {}
                if len(self.lines_miss) != 0:
	#		print self.lines_miss
                        IterateurChain = iter(self.lines_miss)
                        while 1:
				try:
	                                chain = IterateurChain.next()
        	                        lines_chain = self.lines_miss[chain]
                        	        for ligne in lines_chain:
                                	        miss_res = ligne[22:27]
                                        	try:
							if not miss_res in dict_miss[chain]:
                                               			dict_miss[chain].append(miss_res)
	                                        except KeyError:
        	                                        dict_miss[chain] = [miss_res]
				except StopIteration:
					break
			return dict_miss
                else:
                        dict_miss = None
                        return dict_miss	
	
	def ResolutionParser(self):
		if self.ligne_resolution != None:
			ligne_elem = self.ligne_resolution.split()
			Iter_elem = iter(ligne_elem)
			elem = Iter_elem.next()
			while re.search("RESOLUTION" ,elem) == None:
				elem = Iter_elem.next()
			if re.search("[.|0-9]+[0-9]$", elem) != None:
				resln = re.search("[.|0-9]+[0-9]$", elem)
				resln = resln.group()
				if resln[0] == ".":
					resln = resln[1:]
				Reso = resln
				print Reso		
			else:
				Reso = Iter_elem.next()
			ResoElem = Reso.split("/")
			try: self.ligne_resolution = max([float(r) for r in ResoElem])
			except ValueError: self.ligne_resolution = 77
				#print self.ligne_resolution
		return self.ligne_resolution
	
	def ExperimentTypeParser (self): 
		"""Fonction permettant de parser la ligne indiquant la methode exp. de resolution de la structure. 
		Attention, si aucune ligne ne contient 'EXPERIMENT TYPE' n'est indiquee: par defaut, il sera considere que la resolution a ete faite en X ray.
		La RMN n'est pas supportee pour le moment."""
		if self.ligne_ExperimentType != None:
			ligne_elem = self.ligne_ExperimentType.split()
			if ligne_elem[-1] == "NMR":
				return "NMR"
			if ligne_elem[-2]+" "+ligne_elem[-1] == "CRYO-ELECTRON MICROSCOPY":
				return "EM"
			elif re.search("X-RAY", self.ligne_ExperimentType) != None:
				return "X"
			else: return "UKN"
		else: return "NA"
	def rfactor_parser (self):
		list_lines = self.lines_rfactor
		list_rfactors = []
		if len(list_lines) != 0:
                	for lines in list_lines:
                        	if re.search("WORKING SET", lines) != None or re.search("WORKING + TEST SET", lines) != None:
                                        words = lines.split()
                                        if words[-1] != 'NULL' and  words[-1] != ':NULL' and words[3] == 'VALUE' and words[4] == '(WORKING':
						rfact = re.search("[.|0-9]+[0-9]$", words[-1])
						rfact = rfact.group()
	                                        list_rfactors.append(rfact)
			if len(list_rfactors) == 0: 
				list_rfactors.append(99)
				print "r-factor missing"
		else:
			list_rfactors.append(99)
		return list_rfactors[0]			
					
	
	def SEQRES_Parser (self) :
		"""Methode pour parser les lignes PDB du champ SEQRES pour des proteines 
		et renvoyer un dico de sequence en code 3 lettres. Le dictionnaire est range par chaine proteique"""
		DictSEQRES_sequences = {}
		#Iteration sur les chaines
		#print self._DictSEQRES #***
		if len(self._DictSEQRES) > 0: self.flag_seqres = 1
		IterateurChaines = iter(self._DictSEQRES )
		while 1:
			try :
				#Recup des lignes relatives a la chaine en cours
				Chaine = IterateurChaines.next()
				LignesChaine = self._DictSEQRES[Chaine]

				#Verification : La chaine est-elle proteique (verif du premier aa)?
				#Si oui, on la prend en compte, sinon, rien n'est fait
				#print LignesChaine[0][19:70] #***
				elements = LignesChaine[0][19:70].split() #test de la premiere ligne
				#si le premier res de la sequence est acetyle et que ce la est signale dans SEQRES par ACE en premiere position (ou autre) --> je ne tient pas compte de ce sigle
#				if elements[0] in Definitions.SiglesDebSeqNPC  : elements.pop(0)
#				test = [Definitions.EquiAA_3to1lettres.has_key(e) for e in elements]
				NombreNonResidu = 0 #Calcul du pourcentage de mol non proteique dans la premiere ligne de la sequence
#				for aa in test:	
#					if aa == False: NombreNonResidu +=1
				for e in elements:
					if e not in Definitions.AA_standard:
						NombreNonResidu +=1
				PourcNonResidu = NombreNonResidu/len(elements)
				#print test
				#if (False in test[1:] or  len(elements)<13):#La chaine n'est pas proteique : elle est a proscrire
				if ( PourcNonResidu > 0.25 ):#La chaine n'est pas proteique (+ de 30% de non residus): elle est a proscrire
					self._ChaineAProscrire.append(Chaine)
					print "Chaine not considered (more than 30% non amino acids) ! :",self._ChaineAProscrire
				
				else : #la Chaine semble proteique (d'apres la premiere ligne !)

					#Enregistrement du nom des chaines prot pour SEQRES
					self._ChainesProtSEQRES.append(Chaine)
					
					#Ajout de la chaine dans le dico de sequences prot
					DictSEQRES_sequences[Chaine] = []
										
					#Iteration sur les lignes
					IterateurLignes = iter(LignesChaine)
					while 1:
						try :
							Ligne = IterateurLignes.next()
							ColonnesSequences = Ligne[19:70]
							ColonnesSequences_atoms = ColonnesSequences.split()
							for res in ColonnesSequences_atoms:
								if res in Definitions.AA_3Lettres:		
							#print ColonnesSequences_atoms
									try:
										DictSEQRES_sequences[Chaine].append(res)
									except KeyError:
										pass
						except StopIteration:
							break	
					#si le premier res de la sequence est acetyle et que ce la est signale dans SEQRES par ACE (ou autre) en premiere position  --> je ne tient pas compte de ce sigle
					if DictSEQRES_sequences[Chaine][0]in Definitions.SiglesDebSeqNPC: DictSEQRES_sequences[Chaine].pop(0)
					#if test[0] == False : DictSEQRES_sequences[Chaine].pop(0) #si la prot commence par une autre mol qu'un aa, on enleve cette mol de la sequence
			except StopIteration:
				break	

		#print DictSEQRES_sequences #**
#		print self._ChainesProtSEQRES
		self.Dict_seqres = DictSEQRES_sequences
		return DictSEQRES_sequences


	def  ATOM_Parser (self) :
		"""Methode pour parser les lignes PDB des champs ATOM et associes (i.e., SIGATM)  pour des proteines 
		et renvoyer un dico de structure. Le dictionnaire est range par chaine proteique
		Pour chaque chaine prot, la sequence est un liste de dictionnaires. Chaque dictionnaire comporte les info pour un atome
		avec 2 champs ATOM et SIGATM. Pour chacun des champs, la liste des informations est la suivante:
		Numero de l'atome
		Nom de l'atome
		Id de la position alternative (si besoin)
		Nom du residu 
		Numero du residu dans la sequence
		Coord X (pour SIGATM: sd en Angstroms)
		Coord Y	(pour SIGATM: sd en Angstroms)
		Coord Z	(pour SIGATM: sd en Angstroms)
		Bfact (pour SIGATM: sd)"""

		#DictATOM_informations = {}
		DictATOM_informations_MODEL = []


		#Iteration sur les chaines
		#print self._DictATOM #***
		IterateurModels = iter(self._DictATOM )
		while 1:
			try :
				count_residue = 0
				flag_enter_chain = 0
				#Recup du dictionnaire relatif au modele en cours
				Model = IterateurModels.next()
#				seqres = self.SEQRES_Parser()
				#print Model
				IterateurChaines= iter(Model)
				DictATOM_informations = {}
				while 1 : 
					try:
						#Recup des lignes relatives a la chaine en cours
						Chaine = IterateurChaines.next()
						#print Chaine
						LignesChaine = Model[Chaine]
						flag_enter_chain = 0
						#Verification : La chaine est-elle proteique (verif du premier aa)?
						#Si oui, on la prend en compte, sinon, rien n'est fait
						#print LignesChaine[0][17:20] #***
						if not self._DictSEQRES.has_key(Chaine) or not self.Dict_seqres.has_key(Chaine): self.flag_seqres = 0
#SEQRES
						if (LignesChaine[0][17:20] in Definitions.AA_3Lettres and Chaine not in self._ChaineAProscrire): # and self._DictSEQRES.has_key(Chaine)):
							#print LignesChaine[0][17:20]
							#Enregistrement du nom des chaines prot pour ATOM
							if Chaine not in self._ChainesProtATOM:
								self._ChainesProtATOM.append(Chaine)
							#Ajout de la chaine dans le dico de struct prot
							DictATOM_informations[Chaine] = []
							res_num_prev = "-999 "
							count_residue = 0
							flag_enter_chain = 1
							#Iteration sur les lignes
							IterateurLignes = iter(LignesChaine)
							while 1:
								try :
									#Recuperation de la ligne
									Ligne = IterateurLignes.next()
									#print Ligne
									#Si on est sur une ligne ATOM
									flag_ent = 0
									if Ligne[:6]=="ATOM  " or Ligne[:6]=="HETATM":
										if self.flag_seqres == 1:
											if Ligne[17:20] in self.Dict_seqres[Chaine]:
												flag_ent = 1
										else:
											if Ligne[17:20] in Definitions.AA_3Lettres:
												flag_ent = 1
										if flag_ent == 1: 
										#if  not Ligne[22:26] < res_num_prev:
											#Preparation d'un dico pour accueillir les info de l'atome en cours
											Dico_Info_atome = {'ATOM':[], 'SIGATM':[]}
											#Numero de l'atome
											Dico_Info_atome['ATOM'].append(int(Ligne[6:11]))
											#Nom de l'atome
											Dico_Info_atome['ATOM'].append(Ligne[12:16])
											#Id de la position alternative (si besoin)
											Dico_Info_atome['ATOM'].append(Ligne[16])
											#Nom du residu 
											Dico_Info_atome['ATOM'].append(Ligne[17:20])
											#Numero du residu dans la sequence
											Dico_Info_atome['ATOM'].append(Ligne[22:27])
											if Ligne[22:27] != res_num_prev:
												count_residue += 1	
											#Coord X		
											Dico_Info_atome['ATOM'].append(float(Ligne[30:38]))
											#Coord Y
											Dico_Info_atome['ATOM'].append(float(Ligne[38:46]))
											#Coord Z
											Dico_Info_atome['ATOM'].append(float(Ligne[46:54]))
											#Bfact
											Dico_Info_atome['ATOM'].append(float(Ligne[60:66]))
											#Occupancy
											Dico_Info_atome['ATOM'].append(float(Ligne[54:60]))
											DictATOM_informations[Chaine].append(Dico_Info_atome)
											res_num_prev = Ligne[22:27]
										else:
											print Ligne
									#Si on est sur une ligne SIGATM
									elif Ligne[:6]=="SIGATM" :
										#Numero de l'atome
										Dico_Info_atome['SIGATM'].append(int(Ligne[6:11]))
										#Nom de l'atome
										Dico_Info_atome['SIGATM'].append(Ligne[12:16])
										#Id de la position alternative (si besoin)
										Dico_Info_atome['SIGATM'].append(Ligne[16])
										#Nom du residu
										Dico_Info_atome['SIGATM'].append(Ligne[17:20])
										#Numero du residu dans la sequence
										Dico_Info_atome['SIGATM'].append(Ligne[22:27]) #prise en compte du insertion code
										#sd Coord X
										Dico_Info_atome['SIGATM'].append(float(Ligne[30:38]))
										#sd Coord Y
										Dico_Info_atome['SIGATM'].append(float(Ligne[38:46]))
										#sd Coord Z
										Dico_Info_atome['SIGATM'].append(float(Ligne[46:54]))
										#sd Bfact
										Dico_Info_atome['SIGATM'].append(float(Ligne[60:66]))
										#sd Occupancy
										Dico_Info_atome['SIGATM'].append(float(Ligne[54:60]))
									
									#DictATOM_informations[Chaine].append(Dico_Info_atome)
									#print Dico_Info_atome
								except StopIteration:
									break
					except StopIteration:
						break
                                        if count_residue < 3 and flag_enter_chain == 1:
                                        	del DictATOM_informations[Chaine]
                                        	print "chain length less than 3"

				DictATOM_informations_MODEL.append(DictATOM_informations)	
			except StopIteration:
				break	

		#print DictATOM_informations #**
		return DictATOM_informations_MODEL #liste de dictionnaires. Un dico par modele
		#Ex : [{'A': [{'SIGATM': [], 'ATOM': [1,...
		#     'B': [{'SIGATM': [], 'ATOM': [35..   }  #Fin Model 1
		#     {'A': [{'SIGATM': [], 'ATOM': [1..
		#     'B': [{'SIGATM': [], 'ATOM': [35..   }  #Fin Model 2 ]
	
#-------------------------------------------------------------------------------------------------------------		
		

		
		
# TEST ----------------------		
def main ():
	print "PDB1"
#	try:
	P1 = PDBParser("10MH.pdb")
	P1.SEQRES_Parser()
	print P1.ATOM_Parser()
#	except Exception,msg:
#		print >>sys.stderr,msg
#		pass

	print "PDB2"
#	try:
	P2 = PDBParser("PDBs/pdb1ee8.ent")
	P2.SEQRES_Parser()
	print P2.ATOM_Parser()
#	except Exception, msg:
#		print >>sys.stderr,msg
#		pass

if __name__ == "__main__":
	main()
	
