import re

__doc__ ="""Ce module parse le fichier dir.des.scop.txt_1.71 de scop pour obtenir la classe SCOP d'un domaine a partir de l'id pdb et de la chaine"""

DefIDSCOPtoClasse = {"a":"a","b":"b","c":"a/b","d":"a+b","e":"MdP","f":"M","g":"SmP","h":"CC","i":"L","j":"P","k":"D","-":"_"}

class ParserSCOP :
	
		def __init__(self,nomFichierSCOP):
			"""Initialisation du Parser SCOP"""
			FichierSCOP = open(nomFichierSCOP, 'r')
			lignesFichierSCOP = FichierSCOP.readlines()
			FichierSCOP.close()
			
			self.Lignes_dir_des_scop = lignesFichierSCOP 
			
		def getSCOP (self,nomPDB, chaine, longueurProt, start, end):
			"""Renvoie un dictionnaire contenant l'annotation scop.
			Les classes sont a, b, a/b, a+b et _. Elles servent de cle.
			Les deb et fin des domaines correspondent a la numerotation dans la sequence A PARTIR de 1, mis sous forme de liste.
			Comme plusieurs domaines de la meme classe possible, a priori,ajout du num de domaine a la cle."""

			SCOP={}
			scopid_list = []
			scopid_lim = {}
			if chaine == ' ': IDchaine = ''
			else : IDchaine = chaine
			testTaillelimiteDom = 0
			chain_list = {}
			#Parcours des lignes. On ne retient que les lignes d'interet
			numDom = 0
			for ligne in self.Lignes_dir_des_scop :

				if re.search(nomPDB.lower()+" "+IDchaine, ligne) !=None or (re.search(nomPDB.lower(), ligne) != None and re.search(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*$", ligne) != None) or (re.search(nomPDB.lower(), ligne) != None and re.search("," + IDchaine+":"+"*-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*,", ligne) != None):
					info_str = []
					limiteDom = []
					#print ligne
					word_info = ligne.split()[5]
					#chain_list = re.findall("[A-Z](?=:)", word_info)
					#Recup des limites du domaine
					info = re.search(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*$", ligne)
					if re.search(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*,", ligne) != None:
						info_ext = re.findall(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*,", ligne)
						#print info_ext
					else: info_ext = None
					if info == None and info_ext == None:
						print "error reading the scop class: pls check the file"
						if re.search(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*,", ligne) != None:
							info = re.search(IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*,", ligne)
							info_str = info.group()
							info_str = info_str[:-1]
						elif re.search("," + IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*$", ligne) != None:
							info = re.search("," + IDchaine+":"+"-*[0-9]*[A-Z]*-*[0-9]*[A-Z]*$", ligne)
							info_str =  info.group()
							info_str = info_str[1:]
						else: print "no scop record found!!!!"
					if info != None or info_ext != None:
						if info_ext != None:
							for elem in info_ext: info_str.append(elem[:-1])
						if info != None: info_str.append(info.group())
					if chaine == " ":
						for elem in info_str:
							limiteDom.extend(re.split('-(?=[0-9])',elem[0:]))
					else:
						for elem in info_str:
							limiteDom.extend(re.split('-(?=[0-9])',elem[2:]))
					#print limiteDom
					if len(limiteDom) == 1 :
						testTaillelimiteDom = 1
						if limiteDom == ["-"] or  limiteDom == [""] or limiteDom == [":"]:
							limiteDom = [start, end]
					if '' in limiteDom: limiteDom.remove('')
					limiteDom = [str(limit).strip(":") for limit in limiteDom] #Dernier nettoyage
					#Recup de la classe
					classe = ligne.split()[2][0]
					SCOP[DefIDSCOPtoClasse[classe]+str(numDom)]=[l for l in limiteDom ]
					scopid_list.append(ligne.split()[3])
					scopid_lim[ligne.split()[3][1:]] = [l for l in limiteDom ]
					numDom +=1
					dom_ch = re.findall("[A-Z|0-9](?=:)", word_info)
					chain_list[ligne.split()[3][1:]] = []
					temp_dict = {}
					for elem in dom_ch:
						if temp_dict.has_key(elem): continue
						temp_dict[elem] = 1
						chain_list[ligne.split()[3][1:]].append(elem)
					#print chain_list
							
			#s'il manque une limite a cause d'un insertion code. ex ligne scop : 25206	px	b.40.2.2	d1eu3a1	1eu3 A:2A-96
			if testTaillelimiteDom == 1:
				#tri des domaines par indice de debut
				listedomtrie =[]
				debutlimdom= [SCOP[dom][0] for dom in SCOP]
				listedom = [dom for dom in SCOP]
				i=len(listedom)
				while i!=0:
					mini = min(debutlimdom)
					indexmini = debutlimdom.index(mini)
					listedomtrie.append(listedom[indexmini])
					debutlimdom.pop(indexmini)
					i-=1
				#print listedomtrie
				
				for i in range(len(listedomtrie)):
					if len(SCOP[listedomtrie[i]] ) == 1 :
						if i==0 :#Premier domaine
							if len(listedomtrie ) == 1:#un seul domaine
								#si indice de fin
								if SCOP[listedomtrie[i]][0] > longueurProt-10 and SCOP[listedomtrie[i]][0]  <longueurProt+10 :
									SCOP[listedomtrie[i]] = [1,SCOP[listedomtrie[i]][0]]
								else : #indice de debut
									SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i]][0],longueurProt]
							else : #Plusieurs domaines
								# si quand on ajoute 5 a l'indice scop et qu'on est toujours inferieur a la limite inf du domaine siuvant : indice deb
								if SCOP[listedomtrie[i+1]][0] > SCOP[listedomtrie[i]][0]+5:
									SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i]][0],SCOP[listedomtrie[i+1]][0]-1]
								else : #sinon indice fin
									SCOP[listedomtrie[i]] = [1,SCOP[listedomtrie[i]][0]]
						elif i == len(limdomtrie )-1 : #Dernier domaine
							#si indice de fin (longueur de la prot plus ou moins 10)
							if SCOP[listedomtrie[i]][0] > longueurProt-10 and SCOP[listedomtrie[i]][0]  <longueurProt+10 :
								SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i-1]][1]+1,SCOP[listedomtrie[i]][0]]
							else :#Indice debut
								SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i]][0],longueurProt]
						else : #domaines intermadiaires
							#si quand on ajoute 5 a l'indice scop et qu'on est toujours inferieur a la limite inf du domaine siuvant : indice deb
							if SCOP[listedomtrie[i+1]][0] > SCOP[listedomtrie[i]][0]+5:
								SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i]][0],SCOP[listedomtrie[i+1]][0]-1]
							else :#Indice fin
								SCOP[listedomtrie[i]] = [SCOP[listedomtrie[i-1]][1]+1,SCOP[listedomtrie[i]][0]]
				
			
			
			#if SCOP == {} : raise Exception
			if SCOP == {} : SCOP == {"_":[2,0]}
			return SCOP, scopid_list, scopid_lim, chain_list
		
