import re
import sys
import ChaineObj
import cPickle


__doc__= """Module de definir un objet proteine"""

#-------------------------------------------------------------------------------------------------------------
class Proteine :
	

	def __init__(self, NomFichierPDB,verbose=1):
		try :
			self.IDpdb = re.search("[1-9][0-9|A-Z|a-z]{3}",NomFichierPDB.split('/')[-1]).group().upper()
		except AttributeError : #si le nom du fichier ne contient pas d'identifiant PDB
			self.IDpdb = re.sub("[.][a-z]*","",NomFichierPDB.split('/')[-1])
		if verbose == 1 : print self.IDpdb #***
		self.Chaines = {}
		self.Resolution = None
		self.MethodeExp = None
		self.NombreModelsParChaine = 0
		self.EchecParsing = 0 #!!! Flag pour enregistrer l'echec du parsing PDB. Echec de l'alignement seqres et Atom. !!! 
	
	def set_Resolution (self, Resolution ):
		self.Resolution =Resolution
	
	def add_Chaine (self , IDChaine):
		"""Ajout d'une chaine ou d'un model proteique pour cette chaine si elle a deja ete enregistree"""
		try:
			self.Chaines[IDChaine].add_ModelsStruct()
		except KeyError:
			NewChaine = ChaineObj.ChaineProt( self.IDpdb, IDChaine)
			self.Chaines[IDChaine] = NewChaine
			self.Chaines[IDChaine].add_ModelsStruct()

	def set_TypeExperiment (self, TypeExperiment):
		self.MethodeExp = TypeExperiment

	def CompteModeles (self):
		self.NombreModelsParChaine  += 1

	def ProtTOString_PDB (self):
		"""Impression d'une prot au format PDB"""
		stringListLignePROT = []	
		for i in range(self.NombreModelsParChaine ):
			stringListLignePROT.append("MODEL     %4d\n"%(i+1))
			[self.Chaines[chaine].ModelsStruct[i].ModelTOListOfString_PDB (chaine, stringListLignePROT ) for chaine in self.Chaines][0]
			stringListLignePROT.append("ENDMDL\n")
		return stringListLignePROT

	def PickleProt (self, Fichier ,Procedure=2):
		"""Enregistrement d'une instance de proteine sous forme d'objet Pickle (binaire)"""
		fP=open(Fichier,'w')
		cPickle.dump(self,fP,Procedure)
		fP.close()

#-------------------------------------------------------------------------------------------------------------



# TEST ----------------------		
def main ():
	print "PDB1"
	try:
		P1 = Proteine("PDBs/pdb1iow.ent")
		P1.add_Chaine(" ")
		print P1.Chaines
		print P1.Chaines[" "].NomPDBclean
		
	except Exception, msg:
		print >>sys.stderr, msg
		pass

	print "PDB2"
	try:
		P2 = Proteine("PDBs/pdb1ee8.ent")
		
	except Exception:
		print >>sys.stderr, msg
		pass

if __name__ == "__main__":
	main()
