import sys
import re
from math import *
from os import path
from os import mkdir
from os import popen
from os import listdir
from os import system
from os import getcwd
import getopt
import dom_sf


class GenException (Exception):
        def __init__(self):
                print >>sys.stderr, "GDT_TS calculation failed!!"


def rmsd_frag(s1,s2,coord1,coord2,rms,l):
	distance = 0
	list_dist = []
	sum = 0
	diff_sqr = 0
	for i in range(l):
		c1 = coord1[s1+i]
		c2 = coord2[s2+i]
		for j in range(3):
			distance += pow((c2[j]-c1[j]),2)
		dist = sqrt(distance)
		list_dist.append(dist)
		sum += dist
	avg = float(sum)/float(l)
	for i in range(l):
		#diff_sqr += pow((list_dist[i]-avg),2)
		diff_sqr += pow((list_dist[i]),2)
	mean_diff_sqr = float(diff_sqr)/float(l)
	rmsd = sqrt(mean_diff_sqr)
	return rmsd
		

def main(argv=None):
	if argv == None:
		argv = sys.argv
	try: 
		opts, args = getopt.getopt(argv[1:], "p1:p2:r1:r2:", ["help"])
	except getopt.error: 
		print "error in command line input"
		raise GenException
	DicoOpt = dict(opts)
	if DicoOpt.has_key("-p1"):
                pdb1 = DicoOpt["-p1"]
	if DicoOpt.has_key("-p2"):
               pdb2 = DicoOpt["-p2"]
	if DicoOpt.has_key("-r1"):
        	seq1 = DicoOpt["-r1"]
	if DicoOpt.has_key("-r2"):
                seq2 = DicoOpt["-r2"]
	coord1 = {}
	coord2 = {}
	neq = {}
	percent_neq = {}
	sf_neq = {}
	avg_sf = {}
	lga_sf = {}
	sum_percent = 0
	count_percent = 0
	dictionary_sf = dom_sf.dict_sf
	list_rms = [1.0,2.0,3.0,5.0]
	list_cutoff = [0.5,1.0,1.5,2.0,2.5,3.0,3.5,4.0,4.5,5.0,5.5,6.0,6.5,7.0,7.5,8.0]
	LGA = {}
	try:
		dict_lcs = {}
		dict_gdt = {}
		file1_pdb = pdb1
		if not path.isfile(file1_pdb):
			print "Error in parsing fitted PDBs\n"
			raise GenException
		file2_pdb = pdb2
		if not path.isfile(file2_pdb):
                        print "Error in parsing fitted PDBs\n"
			raise GenException
		f1 = open(file1_pdb,'r')
		lines1 = f1.readlines()
		f1.close()
		ct1 = 0
		res1 = -100
		for l1 in lines1[:-1]:
			el = l1.split()
			el1 = [l1[30:37],l1[38:45],l1[46:53]]
			if el[0] == 'ATOM' and el[2] == 'CA':
				res2 = int(l1[22:26])
				if res1 != res2: 
					res1 = res2
					ct1 += 1
				coord1[ct1] = [float(el1[0]),float(el1[1]),float(el1[2])]
		f2 = open(file2_pdb,'r')
                lines2 = f2.readlines()
                f2.close()
                ct2 = 0
		res1 = -100
                for l1 in lines2[:-1]:
                        el = l1.split()
			el1 = [l1[30:37],l1[38:45],l1[46:53]]
                        if el[0] == 'ATOM' and el[2] == 'CA':
                                res2 = int(l1[22:26])
                                if res1 != res2: 
                                        res1 = res2
                                        ct2 += 1
                                coord2[ct2] = [float(el1[0]),float(el1[1]),float(el1[2])]
		if ct1 < ct2: min_len = ct1
		else: min_len = ct2
#		al = open(aln_file,'r')
#		lines_al = al.readlines()
#		al.close()
		if len(lines_al) < 3: 
			print "Error in parsing fitted PDBs\n"
			raise GenException
#		seq1 = lines_al[2][:-2]
#		seq2 = lines_al[5][:-2]
		if len(seq1) != len(seq2): 
			print "Error in parsing fitted PDBs\n"
			raise GenException
		count1 = 0
		count2 = 0
		list_respairs = []
		for i in range(len(seq1)):
			if seq1[i] != '-':
				count1 += 1
				if seq2[i] != '-':
					count2 += 1
					list_respairs.append([count2,count1]) # first pdb (file2_pdb) is the reference
			elif seq2[i] != '-':
				count2 += 1
		if len(list_respairs) == 0: 
			raise GenException
		neq[pair] = 0
		if not ct1 == count2 and not ct2 == count1: 
			print "Error in parsing fitted PDBs\n"
			raise GenException
		fr = 0
		#print dict_lcs
		for cutoff in list_cutoff:
			neq[cutoff] = 0	
			for rp in list_respairs:	
				dist = 0.0
				flag_calc = 0
				for i in range(3):
					try:
						dist += pow((coord1[rp[0]][i] - coord2[rp[1]][i]),2)
					except KeyError:
						flag_calc = 1 
						break
				if flag_calc == 1: raise GenException
				distance = sqrt(dist)
				if distance < cutoff:
					neq[cutoff] = neq[cutoff]+1
			#print "neq for cutoff %f is %d"%(cutoff,neq[cutoff])
			dict_gdt[cutoff] = (float(neq[cutoff])*100)/float(min_len)
		#print dict_gdt
			#percent_neq[pair] = float(neq[pair])/float(len(list_respairs))
		#if percent_neq[pair] < 0.01: continue
		k = len(list_cutoff)
		sum_gdt = 0
		for i in range(1,k+1):
                        sum_gdt += (k-i+1)*dict_gdt[list_cutoff[i-1]]
                S_gdt = sum_gdt*(float(2)/float(k*(k+1)))
		if S_gdt == None: return -1
		else: return S_gdt

	except Exception:
		return -1
		
if __name__ == "__main__":
	main()
