"""Needleman-Wunch algorithm"""



#----------------------------------------------------------------------------------------------------------------------------
def ConstructionMatrice (Longueur_seq1, Longueur_seq2, value): 
	"""Construction d'une matrice de taille Longueur_seq1*Longueur_seq2, initialisees a value.
	Attention : prevention du passage par valeur uniquement pour les dictionnaires actuellement
	NB : Longueur_seq1 = ncol , Longueur_seq2= nrow"""
	Mat = []
	for i in range(Longueur_seq2):
		if value.__class__ == dict:
			ligneSeq1 = []
			for j in range(Longueur_seq1):
				ligneSeq1.append(value.copy())
			Mat.append(ligneSeq1)
		else:
			Mat.append([value]*Longueur_seq1)
	#print Mat #***
	return Mat
#----------------------------------------------------------------------------------------------------------------------------

#----------------------------------------------------------------------------------------------------------------------------
def PrintMatrice (Matrice, cle):
	"""Affiche la matrice de score necessaire pour needle: chaque case contient un dictionnaire avec les cles score et pointer"""
	ncol = len(Matrice[0])
	nrow = len(Matrice)
	for i in range(nrow):
		print "\t".join ([str(Matrice[i][j][cle]) for j in range(ncol)])
#----------------------------------------------------------------------------------------------------------------------------
	

#----------------------------------------------------------------------------------------------------------------------------
def InitialisationMatrice ( seq1, seq2, MATCH = 1, MISMATCH = -1,GAP = -1 ):
	"""Initialisation de la matrice de score et pointer pour needle"""
	#print GAP
	ScoreMatrix = ConstructionMatrice(len(seq1)+1, len(seq2)+1,{'score':-100,'pointer':None})
	#PrintMatrice (ScoreMatrix) #**
	ScoreMatrix[0][0] = {'score':0, 'pointer':None}
	#PrintMatrice (ScoreMatrix) #**

	#Initialisation de la premiere ligne
	for j in range(len(seq1)+1)[1:]:
		ScoreMatrix[0][j] = {'score':GAP*j, 'pointer':'left'}
	#Initialisation de la premiere colonne
	for i in range(len(seq2)+1)[1:]:
		ScoreMatrix[i][0] = {'score':GAP*i, 'pointer':'up'}
	
	return 	ScoreMatrix
#----------------------------------------------------------------------------------------------------------------------------
	
	
#----------------------------------------------------------------------------------------------------------------------------
def RemplirMatScore (ScoreMatrix, seq1, seq2, MATCH = 1, MISMATCH = -1,GAP = -1 ) :
	"""Calcul des scores d'alignement et enregistrement des pointeurs"""

	#Parcours de la matrice
	for i in range(len(seq2)+1)[1:]:
		for j in range(len(seq1)+1)[1:]:
			scoreDiag = 0
			scoreLeft = 0
			scoreUp = 0
			
			#Calcul du match score
			Lettre2 = seq1[j-1]
			Lettre1 = seq2[i-1]
			if (Lettre1 == Lettre2):
				scoreDiag = ScoreMatrix[i-1][j-1]['score'] + MATCH
			else :
				scoreDiag = ScoreMatrix[i-1][j-1]['score'] + MISMATCH

			#Calcul des gap scores
			scoreUp = ScoreMatrix[i-1][j]['score'] + GAP
			scoreLeft = ScoreMatrix[i][j-1]['score'] + GAP
			
	
			#Choix du meilleur score
			if (scoreDiag >= scoreUp ):
				if (scoreDiag >= scoreLeft):
					ScoreMatrix[i][j] = {'score':scoreDiag, 'pointer':"diag"}
				else :
					ScoreMatrix[i][j] = {'score':scoreLeft, 'pointer':"left"}
			else:
				if (scoreUp >= scoreLeft):
					ScoreMatrix[i][j] = {'score':scoreUp, 'pointer':"up"}
				else:	
					ScoreMatrix[i][j] = {'score':scoreLeft, 'pointer':"left"}
			
#----------------------------------------------------------------------------------------------------------------------------

#----------------------------------------------------------------------------------------------------------------------------
def Alignement (ScoreMatrix, seq1, seq2 ,gapSymbol='_'):
	"""Realisation de l'alignement a partir de la matrice de score"""
	Align1=[]
	Align2=[]

	#On commence a la derniere case de la matrice
	i= len(seq2)
	j= len(seq1)
	
	#
	while 1:
		if ScoreMatrix[i][j]['pointer']==None:
			break
		
		if ScoreMatrix[i][j]['pointer']== 'diag':
			Align1.append(seq1[j-1]) 
			Align2.append(seq2[i-1])
			i -= 1
			j -= 1
		elif ScoreMatrix[i][j]['pointer']== 'left':
			Align1.append(seq1[j-1]) 
			Align2.append(gapSymbol)
			j -= 1
		elif ScoreMatrix[i][j]['pointer']== 'up':
			Align1.append(gapSymbol)
			Align2.append(seq2[i-1]) 
			i -= 1
		#print i,j
	
	Align1.reverse()
	Align2.reverse()
#	print Align1
#	print Align2
	return Align1,Align2

#----------------------------------------------------------------------------------------------------------------------------

#----------------------------------------------------------------------------------------------------------------------------
def Needle ( seq1, seq2, gapSymbol='_', MATCH = 1, MISMATCH = -1,GAP = -1 ):
	"""Deroulement complet de l'alignement par l'algorithme de Needleman et Wunch"""
	#print GAP
	Matrice = InitialisationMatrice ( seq1, seq2, MATCH , MISMATCH ,GAP  )
	RemplirMatScore (Matrice, seq1, seq2, MATCH , MISMATCH ,GAP ) 
	#PrintMatrice (Matrice, 'score')
	#PrintMatrice (Matrice, 'pointer')
	
	return Alignement (Matrice, seq1, seq2,gapSymbol)

#----------------------------------------------------------------------------------------------------------------------------


# TEST ----------------------		
def main ():

	seq1="MMMRDMLKAG"
	seq2="MRLKA"
	seq3=["C","O","E","L","A","C","A","N","T","H"]
	seq4=["P","E","L","I","C","A","N"]
	seq3 = ["A","B","C","*","D"]	
	seq4 = ["A","B","*","*","C","D"]
	#Matrice = ConstructionMatrice (5, 3,5)
	#PrintMatrice (Matrice)
#	Matrice = InitialisationMatrice ( seq3,seq4 )
#	RemplirMatScore (Matrice, seq3,seq4) 
#	PrintMatrice (Matrice, 'score')
#	PrintMatrice (Matrice, 'pointer')
#	Alignement (Matrice, seq3,seq4)
	
	print Needle (seq3,seq4,gapSymbol='.',GAP=-100)


if __name__ == "__main__":
	main()
