import sys
from os import popen
from os import listdir
from os import system
from os import getcwd
import getopt

__doc__="""Lancement principal du programme pour parser les fichiers PDBs
-F :			 Nom du fichier contenant la liste des PDBs a lire
-r : 			 Repertoire contenant les PDBs a lire
-d :			 La liste de fichiers PDB sera traitee a partir de cet indice (indexation a partir de 0)
-f :			 La liste de fichiers PDB sera traitee jusqu a cet indice (indexation a partir de 0)
--rClean : 		 Repertoire contenant les PDBs propres a ecrire
--rPickleProt :  Repertoire contenant les objets Proteines(PDB) apres parsing et enregistrement avec cPickle (procedure 2)
--log : 		 Fichier de rapport d'erreur
ex de lancement :python ~/lib/ParserPDB/MainParserPDB.py -F ListeFichiersPDB -r PDBs --rClean PDBsClean --rPickleProt PDBsPickle -d 536 -f 537
"""
 
Defaut_LOG = "ProblemesParsing.log"

#-------------------------------------------------------------------------------------------------------------
# Erreur pour le lancement du prog
class Usage(Exception):
	def __init__(self, msg):
		self.msg = msg
#-------------------------------------------------------------------------------------------------------------

#-------------------------------------------------------------------------------------------------------------
#Fonction Principale
def main(argv=None):
	"""Fonction principale de lancement du parser PDB. Pour le moment, pas d'option. Donc manque la fonction de process des arguments"""
	
	
	##########################################################################################################
	# Gestion du lancement du programme
	##########################################################################################################
	# Cette partie rend le main plus flexible : le programme peut etre appelee du prompt de python
	if argv is None:
		argv = sys.argv
    	# parse command line options
	try:
		try:
			opts, args = getopt.getopt(argv[1:], "hF:d:f:r:", ["help","ListePDB=","NumPDBdeb=","NumPDBfin=","rClean=","rPickleProt=","log="])
			#print opts, args
		        #the order of short and long flags needs to be the same, so you'll need
			#to specify all the short flags that do have corresponding long flags first, then all the
			#rest of the short flags.
			#opts, args = getopt.getopt(argv[1:], "hea:", ["help","p="])
			#ex. : python EcrireUnMain.py -e -a bi  --p=bu file
			#[('-e', ''), ('-a', 'bi'), ('--p', 'bu')] ['file']
			
		except getopt.error, msg:
				raise Usage(msg)
	except Usage, err:
		print >>sys.stderr, err.msg
		print >>sys.stderr, "for help use --help"
		return 2
    	# process options
	#for o, a in opts:
		#print o
		#if o in ("-h", "--help"):
		#	print __doc__
		#	return 0 
	DicoOpt = dict(opts)
	if DicoOpt.has_key("-h") or DicoOpt.has_key("--help"):
		print __doc__
		return 0
    	# process arguments
	for arg in args:
		pass
		#print args

if __name__ == "__main__":
	sys.exit(main())    

